/* @(#) chapters.c 96/09/17 1.31 */

/* This file describes the individual chapters in the Portfolio documentation.
 * The -name field of every entry corresponds to the name used to reference
 * this chapter from the rest of the autodocs. It is used in the -class entry
 * for these autodocs.
 *
 * Each entry below specifies a description of the chapter, its full name, as
 * well as the manual in which this chapter should be placed.
 */

/**
|||	AUTODOC -class_description -name Kernel
|||	This section presents the reference documentation for the
|||	Kernel folio and associated link libraries.
|||
|||	  Full Name
|||
|||	    Kernel Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Compression
|||	This section presents the reference documentation for the
|||	Compression folio and associated link libraries.
|||
|||	  Full Name
|||
|||	    Compression Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Items
|||	This section presents the reference documentation for the
|||	various types of items supported within Portfolio. Each item type
|||	is listed along with the tags and functions that can be used
|||	to manipulate it.
|||
|||	  Full Name
|||
|||	    Portfolio Item Reference
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Device_Commands
|||	This section presents the reference documentation for the many
|||	I/O commands supported by the various devices in the Portfolio
|||	architecture.
|||
|||	  Full Name
|||
|||	    Device Command Reference
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name IFF
|||	This section presents the reference documentation for the
|||	IFF folio and associated link libraries, which provides services
|||	to read and write files in the IFF format.
|||
|||	  Full Name
|||
|||	    IFF Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name International
|||	This section presents the reference documentation for the
|||	International folio and associated link libraries.
|||
|||	  Full Name
|||
|||	    International Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name JString
|||	This section presents the reference documentation for the
|||	JString folio and associated link libraries.
|||
|||	  Full Name
|||
|||	    JString Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name File
|||	This section presents the reference documentation for the
|||	File folio and associated link libraries.
|||
|||	  Full Name
|||
|||	    File Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Icon
|||	This section presents the reference documentation for the
|||	Icon folio, which provides icon management functions.
|||
|||	  Full Name
|||
|||	    Icon Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Requester
|||	This section presents the reference documentation for the
|||	Requester folio, which provides file management user-interface
|||	components.
|||
|||	  Full Name
|||
|||	    Requester Folio Calls
|||
|||	  Manual
|||
|||	    PPR
|||
**/

/**
|||	AUTODOC -class_description -name EventBroker
|||	This section presents the reference documentation for the
|||	Event Broker and associated link libraries.
|||
|||	  Full Name
|||
|||	    Event Broker Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Examples
|||	This section presents the reference documentation for the
|||	example programs included with this release of Portfolio.
|||
|||	  Full Name
|||
|||	    Example Programs
|||
|||	  Manual
|||
|||	    MPR
**/

/**
|||	AUTODOC -class_description -name Streaming
|||	This section presents the reference documentation for the
|||	Data Streaming software modules.
|||
|||	  Full Name
|||
|||	    Data Streaming Link Library Calls
|||
|||	  Manual
|||
|||	    DPR
**/

/**
|||	AUTODOC -class_description -name Audio
|||	This section presents the reference documentation for the
|||	Audio folio and associated link libraries.
|||
|||	  Full Name
|||
|||	    Audio Folio Calls
|||
|||	  Manual
|||
|||	    APR
**/

/**
|||	AUTODOC -class_description -name AudioPatch
|||	This section presents the reference documentation for the AudioPatch folio,
|||	which provides services to create custom instrument templates.
|||
|||	  Full Name
|||
|||	    Audio Patch Folio Calls
|||
|||	  Manual
|||
|||	    APR
**/

/**
|||	AUTODOC -class_description -name AudioPatchFile
|||	This section presents the reference documentation for the AudioPatchFile folio,
|||	which provides services to load patch (FORM 3PCH) files. These files are created
|||	by tools such as makepatch(@) and ARIA.
|||
|||	  Full Name
|||
|||	    Audio Patch File Folio Calls
|||
|||	  Manual
|||
|||	    APR
**/

/**
|||	AUTODOC -class_description -name Beep
|||	This section presents the reference documentation for the
|||	Beep folio and associated link libraries.
|||
|||	  Full Name
|||
|||	    Beep Folio Calls
|||
|||	  Manual
|||
|||	    APR
**/

/**
|||	AUTODOC -class_description -name DSP
|||	This section presents the reference documentation for the
|||	Audio DSP instruments.
|||
|||	  Full Name
|||
|||	    DSP Instruments
|||
|||	  Manual
|||
|||	    APR
**/

/**
|||	AUTODOC -class_description -name libmusic
|||	This section presents the reference documentation for the
|||	Music link library.
|||
|||	  Full Name
|||
|||	    Music Link Library Calls
|||
|||	  Manual
|||
|||	    APR
**/

/**
|||	AUTODOC -class_description -name EZAudio
|||	This section presents the reference documentation for the "EZ" Audio
|||	example toolboxes. This simple (yet powerful) set of functions is provided
|||	in source code form as part of the Audio Examples set.
|||
|||	  Full Name
|||
|||	    "EZ" Audio Example Toolboxes
|||
|||	  Manual
|||
|||	    APR
**/

/**
|||	AUTODOC -class_description -private -name libaudiodemo
|||	This section presents the reference documentation for the private Audio Demo
|||	link library.
|||
|||	  Full Name
|||
|||	    Audio Demo Link Library Calls (private)
|||
|||	  Manual
|||
|||	    APR
**/

/**
|||	AUTODOC -class_description -name Streaming_Tools
|||	This section presents the reference documentation for the Data Streaming
|||	stream preparation tools.
|||
|||	  Full Name
|||
|||	    Data Streaming Tools
|||
|||	  Manual
|||
|||	    DPR
**/

/**
|||	AUTODOC -class_description -name Shell_Commands
|||	This section presents the reference documentation for the
|||	shell commands used during development.
|||
|||	  Full Name
|||
|||	    Shell Commands
|||
|||	  Manual
|||
|||	    MPR
**/

/**
|||	AUTODOC -class_description -name Dev_Commands
|||	This section presents the reference documentation for some
|||	host commands used during the development cycle.
|||
|||	  Full Name
|||
|||	    Host Development Commands
|||
|||	  Manual
|||
|||	    MPR
**/

/**
|||	AUTODOC -class_description -name Frame2D
|||	This section presents the reference documentation for the
|||	2D graphics framework.
|||
|||	  Full Name
|||
|||	    2D Framework Folio Calls
|||
|||	  Manual
|||
|||	    GPR
**/

/**
|||	AUTODOC -class_description -name Mercury
|||	This section presents the reference documentation for the
|||	Mercury 3D graphics environment.
|||
|||	  Full Name
|||
|||	    Mercury Link Library Calls
|||
|||	  Manual
|||
|||	    GPR
**/

/**
|||	AUTODOC -class_description -name Matrix
|||	This section presents the reference documentation for the
|||	matrix math services.
|||
|||	  Full Name
|||
|||	    Matrix Math Link Library Calls
|||
|||	  Manual
|||
|||	    GPR
**/

/**
|||	AUTODOC -class_description -name Vector
|||	This section presents the reference documentation for the
|||	vector math services.
|||
|||	  Full Name
|||
|||	    Vector Math Link Link Library Calls
|||
|||	  Manual
|||
|||	    GPR
**/

/**
|||	AUTODOC -class_description -name graphicsfolio
|||	This section presents the reference documentation for the
|||	Graphics folio, which provides services to create and display
|||	bitmaps.
|||
|||	  Full Name
|||
|||	    Graphics Folio Calls
|||
|||	  Manual
|||
|||	    GPR
**/

/**
|||	AUTODOC -class_description -name script
|||	This section presents the reference documentation for the
|||	Script folio, which provides services to execute simple scripts.
|||
|||	  Full Name
|||
|||	    Script Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Font
|||	This section presents the reference documentation for the
|||	Font folio, which provides services to load fonts into memory and
|||	render them to the screen.
|||
|||	  Full Name
|||
|||	    Font Folio Calls
|||
|||	  Manual
|||
|||	    GPR
**/

/**
|||	AUTODOC -class_description -name CLT
|||	This section presents the reference documentation for the
|||	triangle engine command list toolkit, which provides low-level
|||	services to interface to the TE.
|||
|||	  Full Name
|||
|||	    Triangle Engine Command List Toolkit
|||
|||	  Manual
|||
|||	    GPR
**/

/**
|||	AUTODOC -class_description -name GState
|||	This section presents the reference documentation for the
|||	GState, which provides routines to help manage Triangle Engine
|||	command list buffers.  GState is used with CLT, the 2D Framework,
|||	and the 3D Pipeline and Framework as a lowest level of managing
|||	command list buffer memory.
|||
|||	  Full Name
|||
|||	    GState (Graphics State)
|||
|||	  Manual
|||
|||	    GPR
**/

/**
|||	AUTODOC -class_description -name DebugConsole
|||	This section presents the reference documentation for the
|||	debug console link library, which provides services to perform
|||	console-style output to a 3DO View.
|||
|||	  Full Name
|||
|||	    Debug Console Link Library Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name fsutils
|||	This section presents the reference documentation for the
|||	FSUtils folio, which provides high-level functions to perform
|||	various file system operations.
|||
|||	  Full Name
|||
|||	    FileSystem Utilities Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name ansi_c
|||	This section presents the reference documentation for some of the
|||	ANSI C functions provided as part of the 3DO development environment.
|||
|||	  Full Name
|||
|||	    ANSI C Link Library Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Math
|||	This section presents the reference documentation for the floating
|||	point math functions provided as part of the 3DO development environment.
|||
|||	  Full Name
|||
|||	    Single Precision Math Library Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Batt
|||	This section presents the reference documentation for the Batt
|||	folio, which provides access to the system's battery-backed clock
|||	and memory.
|||
|||	  Full Name
|||
|||	    Batt Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Date
|||	This section presents the reference documentation for the Date
|||	folio, which provides conversion functions to handle date and time
|||	values.
|||
|||	  Full Name
|||
|||	    Date Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name SaveGame
|||	This section presents the reference documentation for the SaveGame
|||	folio, which provides simple methods for loading and saving compressed
|||	saved game files to storage.
|||
|||	  Full Name
|||
|||	    SaveGame Folio Calls
|||
|||	  Manual
|||
|||	    PPR
**/

/**
|||	AUTODOC -class_description -name Blitter
|||	This section presents the reference documentation for the
|||	Blitter folio, which provides functions for using a
|||	rectangular region of a Bitmap as a texture, and for
|||	performing simple blit operations.
|||
|||	  Full Name
|||
|||	    Blitter Folio Calls
|||
|||	  Manual
|||
|||	    GPR
**/

/**
|||	AUTODOC -class_description -name Tools
|||	This section presents the reference documentation for the graphics
|||	preparation and conversion tools.
|||
|||	  Full Name
|||
|||	    Graphics Tools And Development Libraries
|||
|||	  Manual
|||
|||	    MPR
**/

