#include "mercury.h"

#define vtxdat(a,b,c) a/4., b/4., c/4., a/400., b/400., c/400.

static float icosvtx[] =
{
    vtxdat(0,0,400),
    vtxdat(-358,0,179),
    vtxdat(-111,340,179),
    vtxdat(289,210,179),
    vtxdat(289,-210,179),
    vtxdat(-111,-340,179),
    vtxdat(111,-340,-179),
    vtxdat(-289,-210,-179),
    vtxdat(-289,210,-179),
    vtxdat(111,340,-179),
    vtxdat(358,0,-179),
    vtxdat(0,0,-400)
};

static short icosindex0[]= 
{	
    1 + STXT,
    0,
    5,
    0,
    4,
    3 + PCLK,
    2 + CFAN,
    1 + CFAN + PCLK + PFAN,

    8 + PFAN,
    7 + PCLK,
    5 + CFAN,
    6 + PCLK + PFAN,
    4,

    10 + PCLK,
    3,
    9 + PCLK,
    2,
    8 + PCLK,

    11 + CFAN,
    7 + PCLK + PFAN,
    6,
    10 + CFAN + PCLK,
    9 + CFAN + PFAN,
    0 + STXT + NEWS + PFAN + CFAN + PCLK,
    -1
};
static short icosindex1[]= 
{	
    1 + STXT,
    2,
    5,
    0,
    4,
    3 + PCLK,
    2 + CFAN,
    1 + CFAN + PCLK + PFAN,

    8 + PFAN,
    7 + PCLK,
    5 + CFAN,
    6 + PCLK + PFAN,
    4,

    10 + PCLK,
    3,
    9 + PCLK,
    2,
    8 + PCLK,

    11 + CFAN,
    7 + PCLK + PFAN,
    6,
    10 + CFAN + PCLK,
    9 + CFAN + PFAN,
    0 + STXT + NEWS + PFAN + CFAN + PCLK,
    -1
};
static short icosindex2[]= 
{	
    1 + STXT,
    8,
    5,
    0,
    4,
    3 + PCLK,
    2 + CFAN,
    1 + CFAN + PCLK + PFAN,

    8 + PFAN,
    7 + PCLK,
    5 + CFAN,
    6 + PCLK + PFAN,
    4,

    10 + PCLK,
    3,
    9 + PCLK,
    2,
    8 + PCLK,

    11 + CFAN,
    7 + PCLK + PFAN,
    6,
    10 + CFAN + PCLK,
    9 + CFAN + PFAN,
    0 + STXT + NEWS + PFAN + CFAN + PCLK,
    -1
};
static short icosindex3[]= 
{	
    1 + STXT,
    9,
    5,
    0,
    4,
    3 + PCLK,
    2 + CFAN,
    1 + CFAN + PCLK + PFAN,

    8 + PFAN,
    7 + PCLK,
    5 + CFAN,
    6 + PCLK + PFAN,
    4,

    10 + PCLK,
    3,
    9 + PCLK,
    2,
    8 + PCLK,

    11 + CFAN,
    7 + PCLK + PFAN,
    6,
    10 + CFAN + PCLK,
    9 + CFAN + PFAN,
    0 + STXT + NEWS + PFAN + CFAN + PCLK,
    -1
};
static short icosindex4[]= 
{	
    1 + STXT,
    4,
    5,
    0,
    4,
    3 + PCLK,
    2 + CFAN,
    1 + CFAN + PCLK + PFAN,

    8 + PFAN,
    7 + PCLK,
    5 + CFAN,
    6 + PCLK + PFAN,
    4,

    10 + PCLK,
    3,
    9 + PCLK,
    2,
    8 + PCLK,

    11 + CFAN,
    7 + PCLK + PFAN,
    6,
    10 + CFAN + PCLK,
    9 + CFAN + PFAN,
    0 + STXT + NEWS + PFAN + CFAN + PCLK,
    -1
};

static float icosuv[] = 
{
    1.234, 1., 	1.063, .766,      1., 1.,  .703, .844,      .703, 1.125,   1.063, 1.203,     1.23, 1.,

    1.469, 2.,  1., 2.,      1.063, .766,	.297, .766,  .063, .844,

    2., 0.,      .063, .766, 1.672, 1.219,	1.063, 1.203, 	1.469, 2.,

    1., 1.,      1., 2.,     .016, .75, 2., 0.,    1.672, 1.219,

    0, 0, 0, 0
};

PodGeometry icos0 = 
{
    -358/4.,-340/4., -400/4.,
    716/4., 680/4., 800/4.,
    icosvtx,
    0,
    sizeof(icosvtx)/(6*sizeof(float)),
    0,
    icosindex0,
    icosuv,
    0
};
PodGeometry icos1 = 
{
    -358/4.,-340/4., -400/4.,
    716/4., 680/4., 800/4.,
    icosvtx,
    0,
    sizeof(icosvtx)/(6*sizeof(float)),
    0,
    icosindex1,
    icosuv,
    0
};
PodGeometry icos2 = 
{
    -358/4.,-340/4., -400/4.,
    716/4., 680/4., 800/4.,
    icosvtx,
    0,
    sizeof(icosvtx)/(6*sizeof(float)),
    0,
    icosindex2,
    icosuv,
    0
};
PodGeometry icos3 = 
{
    -358/4.,-340/4., -400/4.,
    716/4., 680/4., 800/4.,
    icosvtx,
    0,
    sizeof(icosvtx)/(6*sizeof(float)),
    0,
    icosindex3,
    icosuv,
    0
};
PodGeometry icos4 = 
{
    -358/4.,-340/4., -400/4.,
    716/4., 680/4., 800/4.,
    icosvtx,
    0,
    sizeof(icosvtx)/(6*sizeof(float)),
    0,
    icosindex4,
    icosuv,
    0
};

#define vtxdatmini(a,b,c) a/4,b/4,c/4,a/400,b/400,c/400

static float miniicosvtx[] =
{
    vtxdatmini(0,0,400),
    vtxdatmini(-358,0,179),
    vtxdatmini(-111,340,179),
    vtxdatmini(289,210,179),
    vtxdatmini(289,-210,179),
    vtxdatmini(-111,-340,179),
    vtxdatmini(111,-340,-179),
    vtxdatmini(-289,-210,-179),
    vtxdatmini(-289,210,-179),
    vtxdatmini(111,340,-179),
    vtxdatmini(358,0,-179),
    vtxdatmini(0,0,-400)
};

static short miniicosindex[] = 
{
    1 + STXT,
	0,
	5,
	0,
	4,
	3 + PCLK,
	2 + CFAN,
	1 + CFAN + PCLK + PFAN,

	8 + PFAN,
	7 + PCLK,
	5 + CFAN,
	6 + PCLK + PFAN,
	4,

	10 + PCLK,
	3,
	9 + PCLK,
	2,
	8 + PCLK,

	11 + CFAN,
	7 + PCLK + PFAN,
	6,
	10 + CFAN + PCLK,
	9 + CFAN + PFAN,
	0 + STXT + NEWS + PFAN + CFAN + PCLK,
	-1
};

static float miniicosuv[] = 
{
    1.234, 1., 	1.063, .766,      1., 1.,  .703, .844,      .703, 1.125,   1.063, 1.203,     1.23, 1.,

    1.469, 2.,  1., 2.,      1.063, .766,	.297, .766,  .063, .844,

    2., 0.,      .063, .766, 1.672, 1.219,	1.063, 1.203, 	1.469, 2.,

    1., 1.,      1., 2.,     .016, .75, 2., 0.,    1.672, 1.219,

    0, 0, 0, 0
};

PodGeometry miniicos = {
    -358/4,-340/4, -400/4,
    716/4, 680/4, 800/4,
    miniicosvtx,
    0,
    sizeof(miniicosvtx)/(6*sizeof(float)),
    0,
    miniicosindex,
    miniicosuv,
    0
};
#define vtxdat2(a,b,c) a/4.,b/4.,c/4.,0.,0.,1.

static float planevtx[] = 
{
    vtxdat2(700,700,0),
    vtxdat2(500,700,0),
    vtxdat2(300,700,0),
    vtxdat2(100,700,0),
    vtxdat2(-100,700,0),
    vtxdat2(-300,700,0),
    vtxdat2(-500,700,0),
    vtxdat2(-700,700,0),

    vtxdat2(700,500,0),
    vtxdat2(500,500,0),
    vtxdat2(300,500,0),
    vtxdat2(100,500,0),
    vtxdat2(-100,500,0),
    vtxdat2(-300,500,0),
    vtxdat2(-500,500,0),
    vtxdat2(-700,500,0),

    vtxdat2(700,300,0),
    vtxdat2(500,300,0),
    vtxdat2(300,300,0),
    vtxdat2(100,300,0),
    vtxdat2(-100,300,0),
    vtxdat2(-300,300,0),
    vtxdat2(-500,300,0),
    vtxdat2(-700,300,0),

    vtxdat2(700,100,0),
    vtxdat2(500,100,0),
    vtxdat2(300,100,0),
    vtxdat2(100,100,0),
    vtxdat2(-100,100,0),
    vtxdat2(-300,100,0),
    vtxdat2(-500,100,0),
    vtxdat2(-700,100,0),

    vtxdat2(700,-100,0),
    vtxdat2(500,-100,0),
    vtxdat2(300,-100,0),
    vtxdat2(100,-100,0),
    vtxdat2(-100,-100,0),
    vtxdat2(-300,-100,0),
    vtxdat2(-500,-100,0),
    vtxdat2(-700,-100,0),

    vtxdat2(700,-300,0),
    vtxdat2(500,-300,0),
    vtxdat2(300,-300,0),
    vtxdat2(100,-300,0),
    vtxdat2(-100,-300,0),
    vtxdat2(-300,-300,0),
    vtxdat2(-500,-300,0),
    vtxdat2(-700,-300,0),

    vtxdat2(700,-500,0),
    vtxdat2(500,-500,0),
    vtxdat2(300,-500,0),
    vtxdat2(100,-500,0),
    vtxdat2(-100,-500,0),
    vtxdat2(-300,-500,0),
    vtxdat2(-500,-500,0),
    vtxdat2(-700,-500,0),

    vtxdat2(700,-700,0),
    vtxdat2(500,-700,0),
    vtxdat2(300,-700,0),
    vtxdat2(100,-700,0),
    vtxdat2(-100,-700,0),
    vtxdat2(-300,-700,0),
    vtxdat2(-500,-700,0),
    vtxdat2(-700,-700,0)
};

static short planeindex[] = 
{
    8 + STXT,
    0,				/* texture */
    0,
    9,
    1,
    10 + PCLK,
    2,
    11 + PCLK,
    3,
    12 + PCLK,
    4,
    13 + PCLK,
    5,
    14 + PCLK,
    6,
    15 + PCLK,
    7,

    8 + 8 + NEWS + PCLK + CFAN,
    0 + 8,
    9 + 8,
    1 + 8,
    10 + 8 + PCLK,
    2 + 8,
    11 + 8 + PCLK,
    3 + 8,
    12 + 8 + PCLK,
    4 + 8,
    13 + 8 + PCLK,
    5 + 8,
    14 + 8 + PCLK,
    6 + 8,
    15 + 8 + PCLK,
    7 + 8,

    8 + 16 + NEWS + PCLK + CFAN,
    0 + 16,
    9 + 16,
    1 + 16,
    10 + 16 + PCLK,
    2 + 16,
    11 + 16 + PCLK,
    3 + 16,
    12 + 16 + PCLK,
    4 + 16,
    13 + 16 + PCLK,
    5 + 16,
    14 + 16 + PCLK,
    6 + 16,
    15 + 16 + PCLK,
    7 + 16,

    8 + 24 + NEWS + PCLK + CFAN,
    0 + 24,
    9 + 24,
    1 + 24,
    10 + 24 + PCLK,
    2 + 24,
    11 + 24 + PCLK,
    3 + 24,
    12 + 24 + PCLK,
    4 + 24,
    13 + 24 + PCLK,
    5 + 24,
    14 + 24 + PCLK,
    6 + 24,
    15 + 24 + PCLK,
    7 + 24,

    8 + 32 + NEWS + PCLK + CFAN,
    0 + 32,
    9 + 32,
    1 + 32,
    10 + 32 + PCLK,
    2 + 32,
    11 + 32 + PCLK,
    3 + 32,
    12 + 32 + PCLK,
    4 + 32,
    13 + 32 + PCLK,
    5 + 32,
    14 + 32 + PCLK,
    6 + 32,
    15 + 32 + PCLK,
    7 + 32,

    8 + 40 + NEWS + PCLK + CFAN,
    0 + 40,
    9 + 40,
    1 + 40,
    10 + 40 + PCLK,
    2 + 40,
    11 + 40 + PCLK,
    3 + 40,
    12 + 40 + PCLK,
    4 + 40,
    13 + 40 + PCLK,
    5 + 40,
    14 + 40 + PCLK,
    6 + 40,
    15 + 40 + PCLK,
    7 + 40,

    8 + 48 + NEWS + PCLK + CFAN,
    0 + 48,
    9 + 48,
    1 + 48,
    10 + 48 + PCLK,
    2 + 48,
    11 + 48 + PCLK,
    3 + 48,
    12 + 48 + PCLK,
    4 + 48,
    13 + 48 + PCLK,
    5 + 48,
    14 + 48 + PCLK,
    6 + 48,
    15 + 48 + PCLK,
    7 + 48,

    0 + STXT + NEWS + PCLK + CFAN,
    -1
};

static float planeuv[] = 
{

    .016, .156,  .016, .016, 	.156, .156,	.156, .016,
    .297, .156,  .297, .016, 	.438, .156, 	.438, .156,
    .563,.156,   .563,.016,     .703,.156,	.703,.016,
    .844,.156,	 .844,.016,	1.00,.156,	1.00,.016,

    .016,.297,	 .016,.156,     .156,.297,	.156,.156,
    .297,.297,	.297,.156,	.438,.297,	.438,.156,
    .563,.297,	.563,.156,	.703,.297,	.703,.156,
    .844,.297,	.844,.156,	 1.00,.297,	1.00,.156,

    .016,.438,	.016,.297,     .156,.438,	.156,.297,
    .297,.438,	.297,.297,     .438,.438,	.438,.297,
    .563,.438,	.563,.297,     .703,.438,	.703,.297,
    .844,.438,	.844,.297,     1.00,.438,	1.00,.297,

    .016,.563,	.016,.438,     .156,.563,	.156,.438,
    .297,.563,	.297,.438,     .438,.563,	.438,.438,
    .563,.563,	.563,.438,     .703,.563,	.703,.438,
    .844,.563,	.844,.438,     1.00,.563,	1.00,.438,

    .016,.703,	.016,.563,     .156,.703,	.156,.563,
    .297,.703,	.297,.563,     .438,.703,	.438,.563,
    .563,.703,	.563,.563,     .703,.703,	.703,.563,
    .844,.703,	.844,.563,     1.00,.703,	1.00,.563,

    .016,.844,	.016,.703,     .156,.844,	.156,.703,
    .297,.844,	.297,.703,     .438,.844,	.438,.703,
    .563,.844,	.563,.703,     .703,.844,	.703,.703,
    .844,.844,	.844,.703,     1.00,.844,	1.00,.703,

    .016,1.00,	.016,.844,     .156,1.00,	.156,.844,
    .297,1.00,	.297,.844,     .438,1.00,	.438,.844,
    .563,1.00,	.563,.844,     .703,1.00,	.703,.844,
    .844,1.00,	.844,.844,     1.00,1.00,	1.00,.844
};

PodGeometry plane = {
    -700./4., -700/4., -.5/4.,
    1400/4.,1400/4.,1./4.,
    planevtx,
    0,
    sizeof(planevtx)/(6*sizeof(float)),
    0,
    planeindex,
    planeuv,
    0
};

#define donutvtx(x,z,cs,sn,dim) (x+600)*cs/(8.*256.), (x+600)*sn/(8.*256.), z/8, x*cs/(dim*256.), x*sn/(dim*256.), z/dim

static float donutvtx[] =
{
    donutvtx(400,164,256,0,432.),
    donutvtx(164,400,256,0,432.),
    donutvtx(-164,400,256,0,500.),
    donutvtx(-400,164,256,0,800.),
    donutvtx(-400,-164,256,0,800.),
    donutvtx(-164,-400,256,0,500.),
    donutvtx(164,-400,256,0,432.),
    donutvtx(400,-164,256,0,432.),
		
    donutvtx(400,164,181,-181,432.),
    donutvtx(164,400,181,-181,432.),
    donutvtx(-164,400,181,-181,500.),
    donutvtx(-400,164,181,-181,800.),
    donutvtx(-400,-164,181,-181,800.),
    donutvtx(-164,-400,181,-181,500.),
    donutvtx(164,-400,181,-181,432.),
    donutvtx(400,-164,181,-181,432.),
		
    donutvtx(400,164,0,-256,432.),
    donutvtx(164,400,0,-256,432.),
    donutvtx(-164,400,0,-256,500.),
    donutvtx(-400,164,0,-256,800.),
    donutvtx(-400,-164,0,-256,800.),
    donutvtx(-164,-400,0,-256,500.),
    donutvtx(164,-400,0,-256,432.),
    donutvtx(400,-164,0,-256,432.),
		
    donutvtx(400,164,-181,-181,432.),
    donutvtx(164,400,-181,-181,432.),
    donutvtx(-164,400,-181,-181,500.),
    donutvtx(-400,164,-181,-181,800.),
    donutvtx(-400,-164,-181,-181,800.),
    donutvtx(-164,-400,-181,-181,500.),
    donutvtx(164,-400,-181,-181,432.),
    donutvtx(400,-164,-181,-181,432.),

    donutvtx(400,164,-256,0,432.),
    donutvtx(164,400,-256,0,432.),
    donutvtx(-164,400,-256,0,500.),
    donutvtx(-400,164,-256,0,800.),
    donutvtx(-400,-164,-256,0,800.),
    donutvtx(-164,-400,-256,0,500.),
    donutvtx(164,-400,-256,0,432.),
    donutvtx(400,-164,-256,0,432.),
		
    donutvtx(400,164,-181,181,432.),
    donutvtx(164,400,-181,181,432.),
    donutvtx(-164,400,-181,181,500.),
    donutvtx(-400,164,-181,181,800.),
    donutvtx(-400,-164,-181,181,800.),
    donutvtx(-164,-400,-181,181,500.),
    donutvtx(164,-400,-181,181,432.),
    donutvtx(400,-164,-181,181,432.),
		
    donutvtx(400,164,0,256,432.),
    donutvtx(164,400,0,256,432.),
    donutvtx(-164,400,0,256,500.),
    donutvtx(-400,164,0,256,800.),
    donutvtx(-400,-164,0,256,800.),
    donutvtx(-164,-400,0,256,500.),
    donutvtx(164,-400,0,256,432.),
    donutvtx(400,-164,0,256,432.),
		
    donutvtx(400,164,181,181,432.),
    donutvtx(164,400,181,181,432.),
    donutvtx(-164,400,181,181,500.),
    donutvtx(-400,164,181,181,800.),
    donutvtx(-400,-164,181,181,800.),
    donutvtx(-164,-400,181,181,500.),
    donutvtx(164,-400,181,181,432.),
    donutvtx(400,-164,181,181,432.)
};

static short donutindex0[] = 
{
    8 + STXT,
    0,				/* texture */
    0,
    9,
    1,
    10 + PCLK,
    2,
    11 + PCLK,
    3,
    12 + PCLK,
    4,
    13 + PCLK,
    5,
    14 + PCLK,
    6,
    15 + PCLK,
    7,
    8 + PCLK,
    0,

    8 + 8 + NEWS + PCLK + CFAN,
    0 + 8,
    9 + 8,
    1 + 8,
    10 + 8 + PCLK,
    2 + 8,
    11 + 8 + PCLK,
    3 + 8,
    12 + 8 + PCLK,
    4 + 8,
    13 + 8 + PCLK,
    5 + 8,
    14 + 8 + PCLK,
    6 + 8,
    15 + 8 + PCLK,
    7 + 8,
    8 + 8 + PCLK,
    0 + 8,

    8 + 16 + NEWS + PCLK + CFAN,
    0 + 16,
    9 + 16,
    1 + 16,
    10 + 16 + PCLK,
    2 + 16,
    11 + 16 + PCLK,
    3 + 16,
    12 + 16 + PCLK,
    4 + 16,
    13 + 16 + PCLK,
    5 + 16,
    14 + 16 + PCLK,
    6 + 16,
    15 + 16 + PCLK,
    7 + 16,
    8 + 16 + PCLK,
    0 + 16,

    8 + 24 + NEWS + PCLK + CFAN,
    0 + 24,
    9 + 24,
    1 + 24,
    10 + 24 + PCLK,
    2 + 24,
    11 + 24 + PCLK,
    3 + 24,
    12 + 24 + PCLK,
    4 + 24,
    13 + 24 + PCLK,
    5 + 24,
    14 + 24 + PCLK,
    6 + 24,
    15 + 24 + PCLK,
    7 + 24,
    8 + 24 + PCLK,
    0 + 24,

    8 + 32 + NEWS + PCLK + CFAN,
    0 + 32,
    9 + 32,
    1 + 32,
    10 + 32 + PCLK,
    2 + 32,
    11 + 32 + PCLK,
    3 + 32,
    12 + 32 + PCLK,
    4 + 32,
    13 + 32 + PCLK,
    5 + 32,
    14 + 32 + PCLK,
    6 + 32,
    15 + 32 + PCLK,
    7 + 32,
    8 + 32 + PCLK,
    0 + 32,

    8 + 40 + NEWS + PCLK + CFAN,
    0 + 40,
    9 + 40,
    1 + 40,
    10 + 40 + PCLK,
    2 + 40,
    11 + 40 + PCLK,
    3 + 40,
    12 + 40 + PCLK,
    4 + 40,
    13 + 40 + PCLK,
    5 + 40,
    14 + 40 + PCLK,
    6 + 40,
    15 + 40 + PCLK,
    7 + 40,
    8 + 40 + PCLK,
    0 + 40,

    8 + 48 + NEWS + PCLK + CFAN,
    0 + 48,
    9 + 48,
    1 + 48,
    10 + 48 + PCLK,
    2 + 48,
    11 + 48 + PCLK,
    3 + 48,
    12 + 48 + PCLK,
    4 + 48,
    13 + 48 + PCLK,
    5 + 48,
    14 + 48 + PCLK,
    6 + 48,
    15 + 48 + PCLK,
    7 + 48,
    8 + 48 + PCLK,
    0 + 48,

    8 - 8 + NEWS + PCLK + CFAN,
    0 + 56,
    9 - 8,
    1 + 56,
    10 - 8 + PCLK,
    2 + 56,
    11 - 8 + PCLK,
    3 + 56,
    12 - 8 + PCLK,
    4 + 56,
    13 - 8 + PCLK,
    5 + 56,
    14 - 8 + PCLK,
    6 + 56,
    15 - 8 + PCLK,
    7 + 56,
    8 - 8 + PCLK,
    0 + 56,

    0 + STXT + NEWS + PCLK + CFAN,
    -1
};
static short donutindex1[] = 
{
    8 + STXT,
    2,				/* texture */
    0,
    9,
    1,
    10 + PCLK,
    2,
    11 + PCLK,
    3,
    12 + PCLK,
    4,
    13 + PCLK,
    5,
    14 + PCLK,
    6,
    15 + PCLK,
    7,
    8 + PCLK,
    0,

    8 + 8 + NEWS + PCLK + CFAN,
    0 + 8,
    9 + 8,
    1 + 8,
    10 + 8 + PCLK,
    2 + 8,
    11 + 8 + PCLK,
    3 + 8,
    12 + 8 + PCLK,
    4 + 8,
    13 + 8 + PCLK,
    5 + 8,
    14 + 8 + PCLK,
    6 + 8,
    15 + 8 + PCLK,
    7 + 8,
    8 + 8 + PCLK,
    0 + 8,

    8 + 16 + NEWS + PCLK + CFAN,
    0 + 16,
    9 + 16,
    1 + 16,
    10 + 16 + PCLK,
    2 + 16,
    11 + 16 + PCLK,
    3 + 16,
    12 + 16 + PCLK,
    4 + 16,
    13 + 16 + PCLK,
    5 + 16,
    14 + 16 + PCLK,
    6 + 16,
    15 + 16 + PCLK,
    7 + 16,
    8 + 16 + PCLK,
    0 + 16,

    8 + 24 + NEWS + PCLK + CFAN,
    0 + 24,
    9 + 24,
    1 + 24,
    10 + 24 + PCLK,
    2 + 24,
    11 + 24 + PCLK,
    3 + 24,
    12 + 24 + PCLK,
    4 + 24,
    13 + 24 + PCLK,
    5 + 24,
    14 + 24 + PCLK,
    6 + 24,
    15 + 24 + PCLK,
    7 + 24,
    8 + 24 + PCLK,
    0 + 24,

    8 + 32 + NEWS + PCLK + CFAN,
    0 + 32,
    9 + 32,
    1 + 32,
    10 + 32 + PCLK,
    2 + 32,
    11 + 32 + PCLK,
    3 + 32,
    12 + 32 + PCLK,
    4 + 32,
    13 + 32 + PCLK,
    5 + 32,
    14 + 32 + PCLK,
    6 + 32,
    15 + 32 + PCLK,
    7 + 32,
    8 + 32 + PCLK,
    0 + 32,

    8 + 40 + NEWS + PCLK + CFAN,
    0 + 40,
    9 + 40,
    1 + 40,
    10 + 40 + PCLK,
    2 + 40,
    11 + 40 + PCLK,
    3 + 40,
    12 + 40 + PCLK,
    4 + 40,
    13 + 40 + PCLK,
    5 + 40,
    14 + 40 + PCLK,
    6 + 40,
    15 + 40 + PCLK,
    7 + 40,
    8 + 40 + PCLK,
    0 + 40,

    8 + 48 + NEWS + PCLK + CFAN,
    0 + 48,
    9 + 48,
    1 + 48,
    10 + 48 + PCLK,
    2 + 48,
    11 + 48 + PCLK,
    3 + 48,
    12 + 48 + PCLK,
    4 + 48,
    13 + 48 + PCLK,
    5 + 48,
    14 + 48 + PCLK,
    6 + 48,
    15 + 48 + PCLK,
    7 + 48,
    8 + 48 + PCLK,
    0 + 48,

    8 - 8 + NEWS + PCLK + CFAN,
    0 + 56,
    9 - 8,
    1 + 56,
    10 - 8 + PCLK,
    2 + 56,
    11 - 8 + PCLK,
    3 + 56,
    12 - 8 + PCLK,
    4 + 56,
    13 - 8 + PCLK,
    5 + 56,
    14 - 8 + PCLK,
    6 + 56,
    15 - 8 + PCLK,
    7 + 56,
    8 - 8 + PCLK,
    0 + 56,

    0 + STXT + NEWS + PCLK + CFAN,
    -1
};
static short donutindex2[] = 
{
    8 + STXT,
    8,				/* texture */
    0,
    9,
    1,
    10 + PCLK,
    2,
    11 + PCLK,
    3,
    12 + PCLK,
    4,
    13 + PCLK,
    5,
    14 + PCLK,
    6,
    15 + PCLK,
    7,
    8 + PCLK,
    0,

    8 + 8 + NEWS + PCLK + CFAN,
    0 + 8,
    9 + 8,
    1 + 8,
    10 + 8 + PCLK,
    2 + 8,
    11 + 8 + PCLK,
    3 + 8,
    12 + 8 + PCLK,
    4 + 8,
    13 + 8 + PCLK,
    5 + 8,
    14 + 8 + PCLK,
    6 + 8,
    15 + 8 + PCLK,
    7 + 8,
    8 + 8 + PCLK,
    0 + 8,

    8 + 16 + NEWS + PCLK + CFAN,
    0 + 16,
    9 + 16,
    1 + 16,
    10 + 16 + PCLK,
    2 + 16,
    11 + 16 + PCLK,
    3 + 16,
    12 + 16 + PCLK,
    4 + 16,
    13 + 16 + PCLK,
    5 + 16,
    14 + 16 + PCLK,
    6 + 16,
    15 + 16 + PCLK,
    7 + 16,
    8 + 16 + PCLK,
    0 + 16,

    8 + 24 + NEWS + PCLK + CFAN,
    0 + 24,
    9 + 24,
    1 + 24,
    10 + 24 + PCLK,
    2 + 24,
    11 + 24 + PCLK,
    3 + 24,
    12 + 24 + PCLK,
    4 + 24,
    13 + 24 + PCLK,
    5 + 24,
    14 + 24 + PCLK,
    6 + 24,
    15 + 24 + PCLK,
    7 + 24,
    8 + 24 + PCLK,
    0 + 24,

    8 + 32 + NEWS + PCLK + CFAN,
    0 + 32,
    9 + 32,
    1 + 32,
    10 + 32 + PCLK,
    2 + 32,
    11 + 32 + PCLK,
    3 + 32,
    12 + 32 + PCLK,
    4 + 32,
    13 + 32 + PCLK,
    5 + 32,
    14 + 32 + PCLK,
    6 + 32,
    15 + 32 + PCLK,
    7 + 32,
    8 + 32 + PCLK,
    0 + 32,

    8 + 40 + NEWS + PCLK + CFAN,
    0 + 40,
    9 + 40,
    1 + 40,
    10 + 40 + PCLK,
    2 + 40,
    11 + 40 + PCLK,
    3 + 40,
    12 + 40 + PCLK,
    4 + 40,
    13 + 40 + PCLK,
    5 + 40,
    14 + 40 + PCLK,
    6 + 40,
    15 + 40 + PCLK,
    7 + 40,
    8 + 40 + PCLK,
    0 + 40,

    8 + 48 + NEWS + PCLK + CFAN,
    0 + 48,
    9 + 48,
    1 + 48,
    10 + 48 + PCLK,
    2 + 48,
    11 + 48 + PCLK,
    3 + 48,
    12 + 48 + PCLK,
    4 + 48,
    13 + 48 + PCLK,
    5 + 48,
    14 + 48 + PCLK,
    6 + 48,
    15 + 48 + PCLK,
    7 + 48,
    8 + 48 + PCLK,
    0 + 48,

    8 - 8 + NEWS + PCLK + CFAN,
    0 + 56,
    9 - 8,
    1 + 56,
    10 - 8 + PCLK,
    2 + 56,
    11 - 8 + PCLK,
    3 + 56,
    12 - 8 + PCLK,
    4 + 56,
    13 - 8 + PCLK,
    5 + 56,
    14 - 8 + PCLK,
    6 + 56,
    15 - 8 + PCLK,
    7 + 56,
    8 - 8 + PCLK,
    0 + 56,

    0 + STXT + NEWS + PCLK + CFAN,
    -1
};
static short donutindex3[] = 
{
    8 + STXT,
    9,				/* texture */
    0,
    9,
    1,
    10 + PCLK,
    2,
    11 + PCLK,
    3,
    12 + PCLK,
    4,
    13 + PCLK,
    5,
    14 + PCLK,
    6,
    15 + PCLK,
    7,
    8 + PCLK,
    0,

    8 + 8 + NEWS + PCLK + CFAN,
    0 + 8,
    9 + 8,
    1 + 8,
    10 + 8 + PCLK,
    2 + 8,
    11 + 8 + PCLK,
    3 + 8,
    12 + 8 + PCLK,
    4 + 8,
    13 + 8 + PCLK,
    5 + 8,
    14 + 8 + PCLK,
    6 + 8,
    15 + 8 + PCLK,
    7 + 8,
    8 + 8 + PCLK,
    0 + 8,

    8 + 16 + NEWS + PCLK + CFAN,
    0 + 16,
    9 + 16,
    1 + 16,
    10 + 16 + PCLK,
    2 + 16,
    11 + 16 + PCLK,
    3 + 16,
    12 + 16 + PCLK,
    4 + 16,
    13 + 16 + PCLK,
    5 + 16,
    14 + 16 + PCLK,
    6 + 16,
    15 + 16 + PCLK,
    7 + 16,
    8 + 16 + PCLK,
    0 + 16,

    8 + 24 + NEWS + PCLK + CFAN,
    0 + 24,
    9 + 24,
    1 + 24,
    10 + 24 + PCLK,
    2 + 24,
    11 + 24 + PCLK,
    3 + 24,
    12 + 24 + PCLK,
    4 + 24,
    13 + 24 + PCLK,
    5 + 24,
    14 + 24 + PCLK,
    6 + 24,
    15 + 24 + PCLK,
    7 + 24,
    8 + 24 + PCLK,
    0 + 24,

    8 + 32 + NEWS + PCLK + CFAN,
    0 + 32,
    9 + 32,
    1 + 32,
    10 + 32 + PCLK,
    2 + 32,
    11 + 32 + PCLK,
    3 + 32,
    12 + 32 + PCLK,
    4 + 32,
    13 + 32 + PCLK,
    5 + 32,
    14 + 32 + PCLK,
    6 + 32,
    15 + 32 + PCLK,
    7 + 32,
    8 + 32 + PCLK,
    0 + 32,

    8 + 40 + NEWS + PCLK + CFAN,
    0 + 40,
    9 + 40,
    1 + 40,
    10 + 40 + PCLK,
    2 + 40,
    11 + 40 + PCLK,
    3 + 40,
    12 + 40 + PCLK,
    4 + 40,
    13 + 40 + PCLK,
    5 + 40,
    14 + 40 + PCLK,
    6 + 40,
    15 + 40 + PCLK,
    7 + 40,
    8 + 40 + PCLK,
    0 + 40,

    8 + 48 + NEWS + PCLK + CFAN,
    0 + 48,
    9 + 48,
    1 + 48,
    10 + 48 + PCLK,
    2 + 48,
    11 + 48 + PCLK,
    3 + 48,
    12 + 48 + PCLK,
    4 + 48,
    13 + 48 + PCLK,
    5 + 48,
    14 + 48 + PCLK,
    6 + 48,
    15 + 48 + PCLK,
    7 + 48,
    8 + 48 + PCLK,
    0 + 48,

    8 - 8 + NEWS + PCLK + CFAN,
    0 + 56,
    9 - 8,
    1 + 56,
    10 - 8 + PCLK,
    2 + 56,
    11 - 8 + PCLK,
    3 + 56,
    12 - 8 + PCLK,
    4 + 56,
    13 - 8 + PCLK,
    5 + 56,
    14 - 8 + PCLK,
    6 + 56,
    15 - 8 + PCLK,
    7 + 56,
    8 - 8 + PCLK,
    0 + 56,

    0 + STXT + NEWS + PCLK + CFAN,
    -1
};
static short donutindex4[] = 
{
    8 + STXT,
    0,				/* texture */
    0,
    9,
    1,
    10 + PCLK,
    2,
    11 + PCLK,
    3,
    12 + PCLK,
    4,
    13 + PCLK,
    5,
    14 + PCLK,
    6,
    15 + PCLK,
    7,
    8 + PCLK,
    0,

    8 + 8 + NEWS + PCLK + CFAN,
    0 + 8,
    9 + 8,
    1 + 8,
    10 + 8 + PCLK,
    2 + 8,
    11 + 8 + PCLK,
    3 + 8,
    12 + 8 + PCLK,
    4 + 8,
    13 + 8 + PCLK,
    5 + 8,
    14 + 8 + PCLK,
    6 + 8,
    15 + 8 + PCLK,
    7 + 8,
    8 + 8 + PCLK,
    0 + 8,

    8 + 16 + NEWS + PCLK + CFAN + STXT,
    2,
    0 + 16,
    9 + 16,
    1 + 16,
    10 + 16 + PCLK,
    2 + 16,
    11 + 16 + PCLK,
    3 + 16,
    12 + 16 + PCLK,
    4 + 16,
    13 + 16 + PCLK,
    5 + 16,
    14 + 16 + PCLK,
    6 + 16,
    15 + 16 + PCLK,
    7 + 16,
    8 + 16 + PCLK,
    0 + 16,

    8 + 24 + NEWS + PCLK + CFAN,
    0 + 24,
    9 + 24,
    1 + 24,
    10 + 24 + PCLK,
    2 + 24,
    11 + 24 + PCLK,
    3 + 24,
    12 + 24 + PCLK,
    4 + 24,
    13 + 24 + PCLK,
    5 + 24,
    14 + 24 + PCLK,
    6 + 24,
    15 + 24 + PCLK,
    7 + 24,
    8 + 24 + PCLK,
    0 + 24,

    8 + 32 + NEWS + PCLK + CFAN + STXT,
    8,
    0 + 32,
    9 + 32,
    1 + 32,
    10 + 32 + PCLK,
    2 + 32,
    11 + 32 + PCLK,
    3 + 32,
    12 + 32 + PCLK,
    4 + 32,
    13 + 32 + PCLK,
    5 + 32,
    14 + 32 + PCLK,
    6 + 32,
    15 + 32 + PCLK,
    7 + 32,
    8 + 32 + PCLK,
    0 + 32,

    8 + 40 + NEWS + PCLK + CFAN,
    0 + 40,
    9 + 40,
    1 + 40,
    10 + 40 + PCLK,
    2 + 40,
    11 + 40 + PCLK,
    3 + 40,
    12 + 40 + PCLK,
    4 + 40,
    13 + 40 + PCLK,
    5 + 40,
    14 + 40 + PCLK,
    6 + 40,
    15 + 40 + PCLK,
    7 + 40,
    8 + 40 + PCLK,
    0 + 40,

    8 + 48 + NEWS + PCLK + CFAN + STXT,
    9,
    0 + 48,
    9 + 48,
    1 + 48,
    10 + 48 + PCLK,
    2 + 48,
    11 + 48 + PCLK,
    3 + 48,
    12 + 48 + PCLK,
    4 + 48,
    13 + 48 + PCLK,
    5 + 48,
    14 + 48 + PCLK,
    6 + 48,
    15 + 48 + PCLK,
    7 + 48,
    8 + 48 + PCLK,
    0 + 48,

    8 - 8 + NEWS + PCLK + CFAN,
    0 + 56,
    9 - 8,
    1 + 56,
    10 - 8 + PCLK,
    2 + 56,
    11 - 8 + PCLK,
    3 + 56,
    12 - 8 + PCLK,
    4 + 56,
    13 - 8 + PCLK,
    5 + 56,
    14 - 8 + PCLK,
    6 + 56,
    15 - 8 + PCLK,
    7 + 56,
    8 - 8 + PCLK,
    0 + 56,

    0 + STXT + NEWS + PCLK + CFAN,
    -1
};

static float donutuv[] =
{
    .125,0.00,	0.00,0.00,		.125,.125,	0.00,.125,
    .125,.250,	0.00,.250,		.125,.375,	0.00,.375,
    .125,.500,	0.00,.500,		.125,.625,	0.00,.625,
    .125,.750,	0.00,.750,		.125,.875,	0.00,.875,
    .125,0.00,	0.00,0.00,

    .250,0.00,	.125,0.00,		.250,.125,	.125,.125,
    .250,.250,	.125,.250,		.250,.375,	.125,.375,
    .250,.500,	.125,.500,		.250,.625,	.125,.625,
    .250,.750,	.125,3.125,		.250,.875,	.125,.875,
    .250,0.00,	.125,0.00,

    .375,0.00,	.250,0.00,		.375,.125,	.250,.125,
    .375,.250,	.250,.250,		.375,.375,	.250,.375,
    .375,.500,	.250,.500,		.375,.625,	.250,.625,
    .375,.750,	.250,.750,		.375,.875,	.250,.875,
    .375,0.00,	.250,0.00,

    .500,0.00,	.375,0.00,		.500,.125,	.375,.125,
    .500,.250,	.375,.250,		.500,.375,	.375,.375,
    .500,.500,	.375,.500,		.500,.625,	.375,.625,
    .500,.750,	.375,.750,		.500,.875,	.375,.875,
    .500,0.00,	.375,0.00,

    .625,0.00,	.500,0.00,		.625,.125,	.500,.125,
    .625,.250,	.500,.250,		.625,.375,	.500,.375,
    .625,.500,	.500,.500,		.625,.625,	.500,.625,
    .625,.750,	.500,.750,		.625,.875,	.500,.875,
    .625,0.00,	.500,0.00,

    .750,0.00,	.625,0.00,		.750,.125,	.625,.125,
    .750,.250,	.625,.250,		.750,.375,	.625,.375,
    .750,.500,	.625,.500,		.750,.625,	.625,.625,
    .750,.750,	.625,.750,		.750,.875,	.625,.875,
    .750,0.00,	.625,0.00,

    .875,0.00,	.750,0.00,		.875,.125,	.750,.125,
    .875,.250,	.750,.250,		.875,.375,	.750,.375,
    .875,.500,	.750,.500,		.875,.625,	.750,.625,
    .875,.750,	.750,.750,		.875,.875,	.750,.875,
    .875,0.00,	.750,0.00,

    0.00,0.00,	.875,0.00,		0.00,.125,	.875,.125,
    0.00,.250,	.875,.250,		0.00,.375,	.875,.375,
    0.00,.500,	.875,.500,		0.00,.625,	.875,.625,
    0.00,.750,	.875,.750,		0.00,.875,	.875,.875,
    0.00,0.00,	.875,0.00
};

PodGeometry donut0 =
{
    -1000/8, -1000/8, -400/8,
    2000/8, 2000/8, 800/8,
    donutvtx,
    0,
    sizeof(donutvtx)/(6*sizeof(float)),
    0,
    donutindex0,
    donutuv,
    0
};

PodGeometry donut1 =
{
    -1000/8, -1000/8, -400/8,
    2000/8, 2000/8, 800/8,
    donutvtx,
    0,
    sizeof(donutvtx)/(6*sizeof(float)),
    0,
    donutindex1,
    donutuv,
    0
};

PodGeometry donut2 =
{
    -1000/8, -1000/8, -400/8,
    2000/8, 2000/8, 800/8,
    donutvtx,
    0,
    sizeof(donutvtx)/(6*sizeof(float)),
    0,
    donutindex2,
    donutuv,
    0
};

PodGeometry donut3 =
{
    -1000/8, -1000/8, -400/8,
    2000/8, 2000/8, 800/8,
    donutvtx,
    0,
    sizeof(donutvtx)/(6*sizeof(float)),
    0,
    donutindex3,
    donutuv,
    0
};

PodGeometry donut4 =
{
    -1000/8, -1000/8, -400/8,
    2000/8, 2000/8, 800/8,
    donutvtx,
    0,
    sizeof(donutvtx)/(6*sizeof(float)),
    0,
    donutindex4,
    donutuv,
    0
};

float cubevtx[] =
{
	0,0,0,-.577,-.577,-.577,
	100,0,0,.577,-.577,-.577,
	100,100,0,.577,.577,-.577,
	0,100,0,-.577,.577,-.577,
	0,0,100,-.577,-.577,.577,
	100,0,100,.577,-.577,.577,
	100,100,100,.577,.577,.577,
	0,100,100,-.577,.577,.577
};

short cubeindex[] =
{
	5 + STXT,
	2,
	6,
	4,
	7,
	0 + PCLK,
	3,
	1 + PCLK,
	2,
	5 + PCLK,
	6,
	7 + PCLK + CFAN,
	3 + CFAN + PFAN,
	4 + NEWS + CFAN + PFAN + PCLK,
	0,
	5,
	1,
	0 + STXT + NEWS + CFAN + PCLK,
	-1,
};

static float cubeuv[] =
{
    1.00, 0.00,
    1.00,1.00,
    0.00, 0.00,
    0.00, 1.00,
    1.00,1.00,
    1.00, 0.00,
    0.00, 1.00,
    0.00, 0.00,
    1.00, 0.00,
    1.00,1.00,
    0.00, 1.00,
    1.00,0.00,
    0.00,0.00,
    1.00,1.00,
    1.00,0.00,
    0.00,1.00,
    1.00,1.00
};
    
PodGeometry cube = 
{
    0.0,0.0,0.0,	
    100.0,100.0,100.0,
    cubevtx,
    0,
    sizeof(cubevtx)/(6*sizeof(float)),
    0,
    cubeindex,
    cubeuv,
    0
};

static float faceticosvtx[] =
{
	0,0,100,			/* 0 */
	-0.491614,-0.356394,0.794549,	/* 0,1,5 */
	-89.5,0,44.75,			/* 1 */
	-0.794549,-0.576519,0.187631,	/* 1,7,5 */
	-27.75,85,44.75,		/* 2 */
	-0.302935,0.932914,-0.187631,	/* 2,9,8 */
	72.25,52.5,44.75,		/* 3 */
	0.302935,0.932914,0.187631,	/* 3,9,2 */
	72.25,-52.5,44.75,		/* 4 */
	0.981132,0,0.187631,		/* 4,10,3 */
	-27.75,-85,44.75,		/* 5 */
	0.302935,-0.932914,0.187631,	/* 5,6,4 */
	27.75,-85,-44.75,		/* 6 */
	-0.302935,-0.932914,-0.187631,	/* 6,5,7 */
	-72.25,-52.5,-44.75,		/* 7 */
	-0.981132,0,-0.187631,		/* 7,1,8 */
	-72.25,52.5,-44.75,		/* 8 */
	-0.605870,0,-0.794549,		/* 8,11,7 */
	27.75,85,-44.75,		/* 9 */
	0.794549,0.576519,-0.187631,	/* 9,3,10 */
	89.5,0,-44.75,			/* 10 */
	0.794549,-0.576519,-0.187631,	/* 10,4,6 */
	0,0,-100,			/* 11 */
	-0.187631,0.576519,-0.794549,	/* 11,8,9 */
	0,0,100,			/* 12 */
	-0.491614,0.356394,0.794549,	/* 0,2,1 */
	0,0,100,			/* 13 */
	0.187631,0.576519,0.794549,	/* 0,3,2 */
	0,0,100,			/* 14 */
	0.605870,0,0.794549,		/* 0,4,3 */
	0,0,100,			/* 15 */
	0.187631,-0.576519,0.794549,	/* 0,5,4 */
	27.75,-85,-44.75,		/* 16 */
	-0.491614,-0.356394,-0.794549,	/* 6,5,7 */
	-72.25,-52.5,-44.75,		/* 17 */
	-0.187631,-0.576519,-0.794549,	/* 7,11,6 */
	-72.25,52.5,-44.75,		/* 18 */
	-0.763102,0.576519,0.187631,	/* 8,1,2 */
	89.5,0,-44.75,			/* 19 */
	0.491614,0.356394,-0.794549,	/* 10,11,9 */
};

static short faceticosshared[] =
{
	1,0,			/* 20      0,1,5 */
	5,0,			/* 21      0,1,5 */
	7,1,			/* 22      1,7,5 */
	5,1,			/* 23      1,7,5 */
	9,2,			/* 24      2,9,8 */
	8,2,			/* 25      2,9,8 */
	9,3,			/* 26      3,9,2 */
	2,3,			/* 27      3,9,2 */
	10,4,			/* 28      4,10,3 */
	3,4,			/* 29      4,10,3 */
	6,5,			/* 30      5,6,4 */
	4,5,			/* 31      5,6,4 */
	5,6,			/* 32      6,5,7 */
	7,6,			/* 33      6,5,7 */
	1,7,			/* 34      7,1,8 */
	8,7,			/* 35      7,1,8 */
	11,8,			/* 36      8,11,7 */
	7,8,			/* 37      8,11,7 */
	3,9,			/* 38      9,3,10 */
	10,9,			/* 39      9,3,10 */
	4,10,			/* 40      10,4,6 */
	6,10,			/* 41      10,4,6 */
	8,11,			/* 42      11,8,9 */
	9,11,			/* 43      11,8,9 */
	2,12,			/* 44      0,2,1 */
	1,12,			/* 45      0,2,1 */
	3,13,			/* 46      0,3,2 */
	2,13,			/* 47      0,3,2 */
	4,14,			/* 48      0,4,3 */
	3,14,			/* 49      0,4,3 */
	5,15,			/* 50      0,5,4 */
	4,15,			/* 51      0,5,4 */
	11,16,			/* 52      6,11,10 */
	10,16,			/* 53      6,11,10 */
	11,17,			/* 54      7,11,6 */
	6,17,			/* 55      7,11,6 */
	1,18,			/* 56      8,1,2 */
	2,18,			/* 57      8,1,2 */
	11,19,			/* 58      10,11,9 */
	9,19,			/* 59      10,11,9 */
};

static short faceticosindex0[] =
{
	0 + STXT,0,20,21,		/* 0,1,5 */
	1 + NEWS + CFAN,22,23,		/* 1,7,5 */
	2 + NEWS + CFAN,24,25,		/* 2,9,8 */
	3 + NEWS + CFAN,26,27,		/* 3,9,2 */
	4 + NEWS + CFAN,28,29,		/* 4,10,3 */
	5 + NEWS + CFAN,30,31,		/* 5,6,4 */
	6 + NEWS + CFAN,32,33,		/* 6,5,7 */
	7 + NEWS + CFAN,34,35,		/* 7,1,8 */
	8 + NEWS + CFAN,36,37,		/* 8,11,7 */
	9 + NEWS + CFAN,38,39,		/* 9,3,10 */
	10 + NEWS + CFAN,40,41,		/* 10,4,6 */
	11 + NEWS + CFAN,42,43,		/* 11,8,9 */
	12 + NEWS + CFAN,44,45,		/* 0,2,1 */
	13 + NEWS + CFAN,46,47,		/* 0,3,2 */
	14 + NEWS + CFAN,48,49,		/* 0,4,3 */
	15 + NEWS + CFAN,50,51,		/* 0,5,4 */
	16 + NEWS + CFAN,52,53,		/* 6,11,10 */
	17 + NEWS + CFAN,54,55,		/* 7,11,6 */
	18 + NEWS + CFAN,56,57,		/* 8,1,2 */
	19 + NEWS + CFAN,58,59,		/* 10,11,9 */
	0 + STXT + NEWS + CFAN,-1,
};

static short faceticosindex1[] =
{
	0 + STXT,2,20,21,		/* 0,1,5 */
	1 + NEWS + CFAN,22,23,		/* 1,7,5 */
	2 + NEWS + CFAN,24,25,		/* 2,9,8 */
	3 + NEWS + CFAN,26,27,		/* 3,9,2 */
	4 + NEWS + CFAN,28,29,		/* 4,10,3 */
	5 + NEWS + CFAN,30,31,		/* 5,6,4 */
	6 + NEWS + CFAN,32,33,		/* 6,5,7 */
	7 + NEWS + CFAN,34,35,		/* 7,1,8 */
	8 + NEWS + CFAN,36,37,		/* 8,11,7 */
	9 + NEWS + CFAN,38,39,		/* 9,3,10 */
	10 + NEWS + CFAN,40,41,		/* 10,4,6 */
	11 + NEWS + CFAN,42,43,		/* 11,8,9 */
	12 + NEWS + CFAN,44,45,		/* 0,2,1 */
	13 + NEWS + CFAN,46,47,		/* 0,3,2 */
	14 + NEWS + CFAN,48,49,		/* 0,4,3 */
	15 + NEWS + CFAN,50,51,		/* 0,5,4 */
	16 + NEWS + CFAN,52,53,		/* 6,11,10 */
	17 + NEWS + CFAN,54,55,		/* 7,11,6 */
	18 + NEWS + CFAN,56,57,		/* 8,1,2 */
	19 + NEWS + CFAN,58,59,		/* 10,11,9 */
	0 + STXT + NEWS + CFAN,-1,
};

static short faceticosindex2[] =
{
	0 + STXT,8,20,21,		/* 0,1,5 */
	1 + NEWS + CFAN,22,23,		/* 1,7,5 */
	2 + NEWS + CFAN,24,25,		/* 2,9,8 */
	3 + NEWS + CFAN,26,27,		/* 3,9,2 */
	4 + NEWS + CFAN,28,29,		/* 4,10,3 */
	5 + NEWS + CFAN,30,31,		/* 5,6,4 */
	6 + NEWS + CFAN,32,33,		/* 6,5,7 */
	7 + NEWS + CFAN,34,35,		/* 7,1,8 */
	8 + NEWS + CFAN,36,37,		/* 8,11,7 */
	9 + NEWS + CFAN,38,39,		/* 9,3,10 */
	10 + NEWS + CFAN,40,41,		/* 10,4,6 */
	11 + NEWS + CFAN,42,43,		/* 11,8,9 */
	12 + NEWS + CFAN,44,45,		/* 0,2,1 */
	13 + NEWS + CFAN,46,47,		/* 0,3,2 */
	14 + NEWS + CFAN,48,49,		/* 0,4,3 */
	15 + NEWS + CFAN,50,51,		/* 0,5,4 */
	16 + NEWS + CFAN,52,53,		/* 6,11,10 */
	17 + NEWS + CFAN,54,55,		/* 7,11,6 */
	18 + NEWS + CFAN,56,57,		/* 8,1,2 */
	19 + NEWS + CFAN,58,59,		/* 10,11,9 */
	0 + STXT + NEWS + CFAN,-1,
};

static short faceticosindex3[] =
{
	0 + STXT,9,20,21,		/* 0,1,5 */
	1 + NEWS + CFAN,22,23,		/* 1,7,5 */
	2 + NEWS + CFAN,24,25,		/* 2,9,8 */
	3 + NEWS + CFAN,26,27,		/* 3,9,2 */
	4 + NEWS + CFAN,28,29,		/* 4,10,3 */
	5 + NEWS + CFAN,30,31,		/* 5,6,4 */
	6 + NEWS + CFAN,32,33,		/* 6,5,7 */
	7 + NEWS + CFAN,34,35,		/* 7,1,8 */
	8 + NEWS + CFAN,36,37,		/* 8,11,7 */
	9 + NEWS + CFAN,38,39,		/* 9,3,10 */
	10 + NEWS + CFAN,40,41,		/* 10,4,6 */
	11 + NEWS + CFAN,42,43,		/* 11,8,9 */
	12 + NEWS + CFAN,44,45,		/* 0,2,1 */
	13 + NEWS + CFAN,46,47,		/* 0,3,2 */
	14 + NEWS + CFAN,48,49,		/* 0,4,3 */
	15 + NEWS + CFAN,50,51,		/* 0,5,4 */
	16 + NEWS + CFAN,52,53,		/* 6,11,10 */
	17 + NEWS + CFAN,54,55,		/* 7,11,6 */
	18 + NEWS + CFAN,56,57,		/* 8,1,2 */
	19 + NEWS + CFAN,58,59,		/* 10,11,9 */
	0 + STXT + NEWS + CFAN,-1,
};

static short faceticosindex4[] =
{
	0 + STXT,0,20,21,		/* 0,1,5 */
	1 + NEWS + CFAN,22,23,		/* 1,7,5 */
	2 + NEWS + CFAN,24,25,		/* 2,9,8 */
	3 + NEWS + CFAN,26,27,		/* 3,9,2 */
	4 + NEWS + CFAN,28,29,		/* 4,10,3 */
	5 + NEWS + CFAN + STXT,2,30,31,	/* 5,6,4 */
	6 + NEWS + CFAN,32,33,		/* 6,5,7 */
	7 + NEWS + CFAN,34,35,		/* 7,1,8 */
	8 + NEWS + CFAN,36,37,		/* 8,11,7 */
	9 + NEWS + CFAN,38,39,		/* 9,3,10 */
	10 + NEWS + CFAN + STXT,8,40,41,/* 10,4,6 */
	11 + NEWS + CFAN,42,43,		/* 11,8,9 */
	12 + NEWS + CFAN,44,45,		/* 0,2,1 */
	13 + NEWS + CFAN,46,47,		/* 0,3,2 */
	14 + NEWS + CFAN,48,49,		/* 0,4,3 */
	15 + NEWS + CFAN + STXT,9,50,51,/* 0,5,4 */
	16 + NEWS + CFAN,52,53,		/* 6,11,10 */
	17 + NEWS + CFAN,54,55,		/* 7,11,6 */
	18 + NEWS + CFAN,56,57,		/* 8,1,2 */
	19 + NEWS + CFAN,58,59,		/* 10,11,9 */
	0 + STXT + NEWS + CFAN,-1,
};

static float faceticosuv[] =
{
	0, 0,	1., 0,	0,1.,
        1., 1.,	1., 0,	0,1.,
        0, 0,	1., 0,	0,1.,
        1., 1.,	1., 0,	0,1.,
        0, 0,	1., 0,	0,1.,

        1., 1.,	1., 0,	0,1.,
        0, 0,	1., 0,	0,1.,
        1., 1.,	1., 0,	0,1.,
        0, 0,	1., 0,	0,1.,
        1., 1.,	1., 0,	0,1.,

        0, 0,	1., 0,	0,1.,
        1., 1.,	1., 0,	0,1.,
        0, 0,	1., 0,	0,1.,
        1., 1.,	1., 0,	0,1.,
        0, 0,	1., 0,	0,1.,

        1., 1.,	1., 0,	0,1.,
        0, 0,	1., 0,	0,1.,
        1., 1.,	1., 0,	0,1.,
        0, 0,	1., 0,	0,1.,
        1., 1.,	1., 0,	0,1.,
};

PodGeometry faceticos0 = 
{
	-89.5,-85,-100,
	179,170,200,
	faceticosvtx,
	faceticosshared,
	sizeof(faceticosvtx)/(6*sizeof(float)),
	sizeof(faceticosshared)/(2*sizeof(short)),
	faceticosindex0,
	faceticosuv,
	0
};

PodGeometry faceticos1 = 
{
	-89.5,-85,-100,
	179,170,200,
	faceticosvtx,
	faceticosshared,
	sizeof(faceticosvtx)/(6*sizeof(float)),
	sizeof(faceticosshared)/(2*sizeof(short)),
	faceticosindex1,
	faceticosuv,
	0
};


PodGeometry faceticos2 = 
{
	-89.5,-85,-100,
	179,170,200,
	faceticosvtx,
	faceticosshared,
	sizeof(faceticosvtx)/(6*sizeof(float)),
	sizeof(faceticosshared)/(2*sizeof(short)),
	faceticosindex2,
	faceticosuv,
	0
};

PodGeometry faceticos3 = 
{
	-89.5,-85,-100,
	179,170,200,
	faceticosvtx,
	faceticosshared,
	sizeof(faceticosvtx)/(6*sizeof(float)),
	sizeof(faceticosshared)/(2*sizeof(short)),
	faceticosindex3,
	faceticosuv,
	0
};

PodGeometry faceticos4 = 
{
	-89.5,-85,-100,
	179,170,200,
	faceticosvtx,
	faceticosshared,
	sizeof(faceticosvtx)/(6*sizeof(float)),
	sizeof(faceticosshared)/(2*sizeof(short)),
	faceticosindex4,
	faceticosuv,
	0
};

static float facetcubevtx[] =
{
	0,0,0,		-1,0,0,	/* 0	-x */
	0,0,100,	0,-1,0,	/* 1	-y */
	0,100,0,	0,0,-1,	/* 2	-z */
	0,100,100,	0,1,0,	/* 3	+y */
	100,0,0,	1,0,0,	/* 4	+x */
	100,0,100,	0,0,1,	/* 5	+z */
	100,100,0,	1,0,0,	/* 6	+x */
	100,100,100,	1,0,0,	/* 7	+x */
};

static short facetcubeshared[] =
{
	0,1,			/* 8	-y */
	0,2,			/* 9	-z */
	1,0,			/* 10	-x */
	1,5,			/* 11	+z */
	2,0,			/* 12	-x */
	2,3,			/* 13	+y */
	3,0,			/* 14	-x */
	3,5,			/* 15	+z */
	4,1,			/* 16	-y */
	4,2,			/* 17	-z */
	5,4,			/* 18	+x */
	5,1,			/* 19	-y */
	6,3,			/* 20	+y */
	6,2,			/* 21	-z */
	7,3,			/* 22	+y */
	7,5,			/* 23	+z */
};

static short facetcubeindex[] =
{
	0 + STXT + PCLK,2,10,12,14,	/* -x */
	8 + NEWS + CFAN + PCLK,16,1,19,	/* -y */
	9 + NEWS + CFAN + PCLK,2,17,21,	/* -z */
	13 + NEWS + CFAN + PCLK,3,20,22,/* +y */
	6 + NEWS + CFAN + PCLK,7,4,18,	/* +x */
	11 + NEWS + CFAN + PCLK,5,15,23,/* +z */
	0 + STXT + NEWS + CFAN + PCLK,-1,
};

static float facetcubeuv[] =
{
	0,0,0,1,1,0,1,1,
	0,0,0,1,1,0,1,1,
	0,0,0,1,1,0,1,1,
	0,0,0,1,1,0,1,1,
	0,0,0,1,1,0,1,1,
	0,0,0,1,1,0,1,1,
};

PodGeometry facetcube =
{
	0,0,0,
	100,100,100,
	facetcubevtx,
	facetcubeshared,
	sizeof(facetcubevtx)/(6*sizeof(float)),
	sizeof(facetcubeshared)/(2*sizeof(short)),
	facetcubeindex,
	facetcubeuv,
	0
};


