/* @(#) UnloadInsTemplateEST_data.h 96/07/16 1.1 */
#ifndef UNLOAD_INS_TEMPLATE_EST_DATA
#define UNLOAD_INS_TEMPLATE_EST_DATA

/*
 *	File:				UnloadInsTemplateEST_data.h
 *	Author:				Eric Matsuno
 *	Creation Date:		
 *
 *	Last Modified by:	Eric L. Hayes
 *	Modification Date:	2/9/96
 *
 *	Version:			M2 1.2
 *
 *	This file contain the arguments used for the UnloadInsTemplate error checking tests(EST).
 *	One structure is created for each argument of UnloadInsTemplate.  UnloadInsTemplate
 *	has one arguments.  There is one structure.  There are three values -
 *	one representing a valid argument; two representing invalid arguments.  UnloadInsTemplateEST
 *	test program will call UnloadInsTemplate with these arguments and return an error code.
 *
 *
 *  Copyright (C) 1996, an unpublished work by The 3DO Company.
 *  All rights reserved. This material contains confidential
 *  information that is the property of The 3DO Company. Any
 *  unauthorized duplication, disclosure or use is prohibited.
 *  
 */


/*	This file was created from a test template.  Within the template, up to 10 structures,
	which represents a command's argument, can be defined.  Before we start, we make sure
	that all structures are undefined.
*/
	#undef	PARAMETER_01
	#undef	PARAMETER_02
	#undef	PARAMETER_03
	#undef	PARAMETER_04
	#undef	PARAMETER_05
	#undef	PARAMETER_06
	#undef	PARAMETER_07
	#undef	PARAMETER_08
	#undef	PARAMETER_09
	#undef	PARAMETER_10


/*	NUM_PARAMS_XX represents the number of argument values contained within the argument structure.
	Before we start, we make sure that all NUM_PARAMS_XX are undefined.
*/
	#undef	NUM_PARAMS_01
	#undef	NUM_PARAMS_02
	#undef	NUM_PARAMS_03
	#undef	NUM_PARAMS_04
	#undef	NUM_PARAMS_05
	#undef	NUM_PARAMS_06
	#undef	NUM_PARAMS_07
	#undef	NUM_PARAMS_08
	#undef	NUM_PARAMS_09
	#undef	NUM_PARAMS_10


/*	By defining PARAMETER_XX, we let the test program know that this structure contains argument
	values.  The test program only look into those structures for which PARAMETER_XX is defined.
*/
	#define	PARAMETER_01		1


/*	The number of argument values contained within each argument structure is given.
*/
	#define	NUM_PARAMS_01		3


/*	ARGUMENT_XX is the argument value which lies at p[index] position within the  PARAM_XX structure.
	p[] array is defined as a local variable in the test program.  This file must be included where
	p[] is declared, and not at the top of the file where the includes are usually placed
*/
	#define	ARGUMENT_01			PARAM_01[(p[1])]


/*	The argument structures are actually declared and filled with default values.  Usually
	structure will contain two values - a valid and an invalid argument
*/
	Item	PARAM_01[]	=	{
								1	,		/*	Legal insTemplate Argument	*/
								-1	,		/*	Bogus insTemplate Argument	*/
								100			/*	Bogus insTemplate Argument	*/
							};
							

#endif					/*	UNLOAD_INS_TEMPLATE_EST_DATA
						*/

