/* @(#) InsPortInfoFT_data.h 96/07/17 1.1 */
#ifndef INS_PORT_INFO_FT_DATA
#define INS_PORT_INFO_FT_DATA

/*
 *	File:				InsPortInfoFT_data.h
 *	Author:				Eric Matsuno
 *	Creation Date:		
 *
 *	Last Modified by:	Eric L. Hayes
 *	Modification Date:	3/1/96
 *
 *	Version:			M2 1.2
 *
 *	This file contain the arguments used for the LoadInsTemplate error checking tests(EST).
 *	One structure is created for each argument of LoadInsTemplate.  LoadInsTemplate
 *	has two arguments.  There are two structures.  In most of the structures, there are two values -
 *	one representing a valid argument; one representing an invalid argument.  The LoadInsTemplateEST
 *	test program will call LoadInsTemplate with these arguments and return an error code.
 *
 *
 *  Copyright (C) 1996, an unpublished work by The 3DO Company.
 *  All rights reserved. This material contains confidential
 *  information that is the property of The 3DO Company. Any
 *  unauthorized duplication, disclosure or use is prohibited.
 *  
 */


/*	This file was created from a test template.  Within the template, up to 10 structures,
	which represents a command's argument, can be defined.  Before we start, we make sure
	that all structures are undefined.
*/
	#undef	PARAMETER_01
	#undef	PARAMETER_02
	#undef	PARAMETER_03
	#undef	PARAMETER_04
	#undef	PARAMETER_05
	#undef	PARAMETER_06
	#undef	PARAMETER_07
	#undef	PARAMETER_08
	#undef	PARAMETER_09
	#undef	PARAMETER_10


/*	NUM_PARAMS_XX represents the number of argument values contained within the argument structure.
	Before we start, we make sure that all NUM_PARAMS_XX are undefined.
*/
	#undef	NUM_PARAMS_01
	#undef	NUM_PARAMS_02
	#undef	NUM_PARAMS_03
	#undef	NUM_PARAMS_04
	#undef	NUM_PARAMS_05
	#undef	NUM_PARAMS_06
	#undef	NUM_PARAMS_07
	#undef	NUM_PARAMS_08
	#undef	NUM_PARAMS_09
	#undef	NUM_PARAMS_10


/*	By defining PARAMETER_XX, we let the test program know that this structure contains argument
	values.  The test program only look into those structures for which PARAMETER_XX is defined.
*/
	#define	PARAMETER_01		1
	#define	PARAMETER_02		1


/*	The number of argument values contained within each argument structure is given.
*/
	#define	NUM_PARAMS_01		2
	#define	NUM_PARAMS_02		1


/*	ARGUMENT_XX is the argument value which lies at p[index] position within the  PARAM_XX structure.
	p[] array is defined as a local variable in the test program.  This file must be included where
	p[] is declared, and not at the top of the file where the includes are usually placed
*/
	#define	ARGUMENT_01			PARAM_01[(p[1])]
	#define	ARGUMENT_02			PARAM_02[(p[2])]


/*	The argument structures are actually declared and filled with default values.  Usually
	structure will contain two values - a valid and an invalid argument. PARAM_01 contains
	more items than specified by NUM_PARAMS_01 because the test program will use the other items 
	without accessing them through PARAM_01[p[1]]
*/
char *		PARAM_01[]	=	{
								"square.dsp"	,
								"bogus_file_name.dsp"	,
								"add.dsp"	,
								"benchmark.dsp"	,
								"cubic_amplifier.dsp"	,
								"deemphcd.dsp"	,
								"delay_f1.dsp"	,
								"delay_f2.dsp"	,
								"envelope.dsp"	,
								"envfollower.dsp"	,
								"expmod_unsigned.dsp",
								"filter_1o1z.dsp",
								"impulse.dsp"	,
								"integrator.dsp",
								"latch.dsp"	,
								"line_in.dsp"	,
								"line_out.dsp"	,
								"maximum.dsp"	,
								"minimum.dsp"	,
								"multiply.dsp"	,
								"multiply_unsigned.dsp"	,
								"noise.dsp"	,
								"pulse.dsp"	,
								"pulse_lfo.dsp"	,
								"randomhold.dsp"	,
								"rednoise.dsp"	,
								"rednoise_lfo.dsp"	,
								"sampler_16_f1.dsp"	,
								"sampler_16_f2.dsp"	,
								"sampler_16_v1.dsp"	,
								"sampler_16_v2.dsp"	,
								"sampler_8_f1.dsp"	,
								"sampler_8_f2.dsp"	,
								"sampler_8_v1.dsp"	,
								"sampler_8_v2.dsp"	,
								"sampler_adp4_v1.dsp"	,
								"sampler_cbd2_f1.dsp"	,
								"sampler_cbd2_f2.dsp"	,
								"sampler_cbd2_v1.dsp"	,
								"sampler_cbd2_v2.dsp"	,
								"sampler_drift_v1.dsp"	,
								"sampler_raw_f1.dsp"	,
								"sampler_sqs2_f1.dsp"	,
								"sampler_sqs2_v1.dsp"	,
								"sawtooth.dsp"	,
								"schmidt_trigger.dsp"	,
								"slew_rate_limiter.dsp"	,
								"square.dsp"	,
								"square_lfo.dsp"	,
								"subtract.dsp"	,
								"svfilter.dsp"	,
								"tapoutput.dsp"	,
								"timesplus.dsp"	,
								"timesplus_noclip.dsp"	,
								"triangle.dsp"	,
								"triangle_lfo.dsp"	
							};
							
	TagArg *	PARAM_02[]	=	{
									NULL		/*	Legal tag Argument	*/
								};
							
#endif /* INS_PORT_INFO_FT_DATA */


