/* @(#) PlaySampleDSPs_FT_data.h 96/07/22 1.1 */
#ifndef PLAY_SAMPLE_DSPS_FT_DATA
#define PLAY_SAMPLE_DSPS_FT_DATA

/*
 *	File:				PlaySampleDSPs_FT_data.h
 *	Author:				Eric L. Hayes
 *	Creation Date:		
 *
 *	Last Modified by:	Eric L. Hayes
 *	Modification Date:	2/12/96
 *
 *	Version:			M2 1.2
 *
 *	This file contains two structures which are used by the test program in PlaySampleDSPs_FT.c.
 *	One structure contains the names of all the sampler dsps to be tested.  The other structure
 *	contains the corresponding audio files which each sampler will play.
 *
 *
 *  Copyright (C) 1996, an unpublished work by The 3DO Company.
 *  All rights reserved. This material contains confidential
 *  information that is the property of The 3DO Company. Any
 *  unauthorized duplication, disclosure or use is prohibited.
 *  
 */



/*	This file was created from a test template.  Within the template, up to 10 structures,
	which represents a command's argument, can be defined.  Before we start, we make sure
	that all structures are undefined.
*/
	#undef	PARAMETER_01
	#undef	PARAMETER_02
	#undef	PARAMETER_03
	#undef	PARAMETER_04
	#undef	PARAMETER_05
	#undef	PARAMETER_06
	#undef	PARAMETER_07
	#undef	PARAMETER_08
	#undef	PARAMETER_09
	#undef	PARAMETER_10


/*	NUM_PARAMS_XX represents the number of argument values contained within the argument structure.
	Before we start, we make sure that all NUM_PARAMS_XX are undefined.
*/
	#undef	NUM_PARAMS_01
	#undef	NUM_PARAMS_02
	#undef	NUM_PARAMS_03
	#undef	NUM_PARAMS_04
	#undef	NUM_PARAMS_05
	#undef	NUM_PARAMS_06
	#undef	NUM_PARAMS_07
	#undef	NUM_PARAMS_08
	#undef	NUM_PARAMS_09
	#undef	NUM_PARAMS_10


/*	By defining PARAMETER_XX, we let the test program know that this structure contains argument
	values.  The test program only look into those structures for which PARAMETER_XX is defined.
*/
	#define	PARAMETER_01		1
	#define	PARAMETER_02		1


/*	The number of argument values contained within each argument structure is given.
*/
	#define	NUM_PARAMS_01		16
	#define	NUM_PARAMS_02		16


/*	ARGUMENT_XX is the argument value which lies at p[index] position within the  PARAM_XX structure.
	p[] array is defined as a local variable in the test program.  This file must be included where
	p[] is declared, and not at the top of the file where the includes are usually placed
*/
	#define	ARGUMENT_01			PARAM_01[(p[1])]
	#define	ARGUMENT_02			PARAM_02[(p[2])]


/*	The argument structures are actually declared and filled with default values.  Usually
	structure will contain two values - a valid and an invalid argument
*/
	char *	PARAM_01[]	=	{
								"sampler_16_f1.dsp"	,
								"sampler_16_v1.dsp"	,
								"sampler_8_f1.dsp"	,
								"sampler_8_v1.dsp"	,
								"sampler_raw_f1.dsp"	,
								"sampler_adp4_v1.dsp"	,
								"sampler_sqs2_f1.dsp"	,
								"sampler_sqs2_v1.dsp"	,
								"sampler_cbd2_f1.dsp"	,
								"sampler_cbd2_v1.dsp"	,
								"sampler_16_f2.dsp"	,
								"sampler_16_v2.dsp"	,
								"sampler_8_f2.dsp"	,
								"sampler_8_v2.dsp"	,
								"sampler_cbd2_f2.dsp"	,
								"sampler_cbd2_v2.dsp"
							};
							
	char *	PARAM_02[]	=	{
								"44K_16B_M.AIFF"	,
								"44K_16B_M.AIFF"	,
								"44K_8B_M.AIFF"	,
								"44K_8B_M.AIFF"	,
								"44K_16B_M.AIFF"	,
								"44K_16B_M_ADP4_FAST.AIFF"	,
								"44K_16B_M_SQS2_FAST.AIFF"	,
								"44K_16B_M_SQS2_FAST.AIFF"	,
								"44K_16B_M_CBD2_FAST.AIFF"	,
								"44K_16B_M_CBD2_FAST.AIFF"	,
								"44K_16B_S.AIFF"	,
								"44K_16B_S.AIFF"	,
								"44K_8B_S.AIFF"	,
								"44K_8B_S.AIFF"	,
								"44K_16B_S_CBD2_FAST.AIFF"	,
								"44K_16B_S_CBD2_FAST.AIFF"
							};
							

#endif						/*	PLAY_SAMPLE_DSPS_FT_DATA
							*/
