#include "Scaffold.h"

/*
 *	Scaffold.c
 *
 *  Provide Class like wrappers for 3do_scaf
 *
 */

SCAFFOLD* Scaffold_Construct( int argc, char* argv[])
{
	SCAFFOLD*	myScaffold;

TOUCH(argc);
TOUCH(argv);
	
	myScaffold = (SCAFFOLD*) malloc(sizeof(SCAFFOLD));
	assert( myScaffold );
	
	/*
	 * Initialize EventBroker
	 */
    assert( InitEventUtility( 1, 0, LC_ISFOCUSED ) >= 0 );
	
	return myScaffold;
} 
/*
 *
 */
void Scaffold_Destruct( SCAFFOLD* scaffold )
{
	free( scaffold );
	TOUCH(scaffold);
}

/*
 *
 */
void Scaffold_Report( SCAFFOLD* scaffold, eTestResult result, char * InString, ...)
{
	LogResult(result, InString );
	TOUCH(scaffold);
}

/*
 *
 */
void Scaffold_ReportPassed( SCAFFOLD* scaffold )
{
	LogResult(PASSED, "" );
	TOUCH(scaffold);
}

/*
 *
 */
void Scaffold_ReportUnTested( SCAFFOLD* scaffold )
{
	LogResult(UNRESOLVED, "--- Test to be Implemented ---" ); 
	TOUCH(scaffold);
}

/*
 *
 */
void Scaffold_ReportComment( SCAFFOLD* scaffold, char * InString, ...)
{
	LogComment(InString );
	TOUCH(scaffold);
}

/*
 *
 */
void Scaffold_ReportError( SCAFFOLD* scaffold, int32 err )
{
	LogError(err );
	TOUCH(scaffold);
}

/*
 *
 */
void Scaffold_ReportFinal( SCAFFOLD* scaffold )
{
	TermScaffold();
	TOUCH(scaffold);
}

/*
 *
 */
void Scaffold_ConsoleComment( SCAFFOLD* scaffold, char * InString, ...)
{
	LogDiagnostic(100, InString );
	TOUCH(scaffold);
}

/*
 *
 */

eTestResult	Scaffold_InteractiveVerify(char* promptString)
{
	return InteractiveVerify(promptString);
}







