/*----------------------------------------------------------------------------------
 *	
 *	FileName:	Test2D_F2.c
 *	Date:		October 10, 1995
 *	By:			Ali Latifi		x3487
 *
 *  Copyright  1995 by The 3DO Company.  All rights reserved.
 *
 *  Modification History:
 *
 *	By:			Date:		Changed:
 * 
 *--------------------------------------------------------------------------------*/

#include "Test2D_F2.h"

#define EXTERNAL_RELEASE	1
#undef NUPUPSIM

extern GState*		gGState;
extern Err			gErr;
extern Boolean		gCPadFlag;

uint32 gTexture[] = {	0xf0f0f0f0, 0xf0f0f0f0,
						0x0f0f0f0f, 0x0f0f0f0f,
						0xf0f0f0f0, 0xf0f0f0f0,
						0x0f05af0f, 0x0f05af0f,
						0xf0fa50f0, 0xf0fa50f0,
						0x0f0f0f0f, 0x0f0f0f0f,
						0xf0f0f0f0, 0xf0f0f0f0,
						0x0f0f0f0f, 0x0f0f0f0f,	};
uint32 ggTexture[] = {	0x0003c000, 0x000ff000,
						0x003ffc00, 0x00ffff00,
						0x03ffffc0, 0x0ffffff0,
						0x3ffffffc, 0xffffffff,
						0xffffffff, 0x3ffffffc,
						0x0ffffff0, 0x03ffffc0,
						0x00ffff00, 0x003ffc00,
						0x000ff000, 0x0003c000, };
uint32 gPipData[] = {	0xffffffff, 0xff000000,
						0xff808080, 0xffff0000,	};

enum {
	eF2_ColoredLines,
	eF2_CopyRect,
	eF2_Draw,
	eF2_DrawLine,
	eF2_DrawList,
	eF2_FillRect,
	eF2_Point,
	eF2_Points,
	eF2_ShadedLines,
	eF2_Triangles,
	eF2_TriFan,
	eF2_TriStrip,

	eF2_Test_End
};

char* Test2D_F2_Names[] = {
	"F2_ColoredLines",
	"F2_CopyRect",
	"F2_Draw",
	"F2_DrawLine",
	"F2_DrawList",
	"F2_FillRect",
	"F2_Point",
	"F2_Points",
	"F2_ShadedLines",
	"F2_Triangles",
	"F2_TriFan",
	"F2_TriStrip",

	""
};

/* -------------------------------------------------------------------------------- */
/* Initialize test suite */
int32 Test2D_F2_Initialize(void)
{
	 return 0;
}

/* -------------------------------------------------------------------------------- */
/* Return the number of test's to preform */
int32 Test2D_F2_Count(void)
{
	return eF2_Test_End-1;
}

/* -------------------------------------------------------------------------------- */
void Test2D_F2( TEST2DAPI* theTest2DAPI, int32 testNumber )
{
	int32				tempNumpoints;
	Point2				tempCorner[4];
	Color4				tempColor[4];
	ControlPadEventData	tempCPad;
	int					i;
	SpriteObj			*tempSprite, *temp1Sprite;

	TOUCH(theTest2DAPI);

	BeginTest(FT, Test2D_F2_Names[testNumber]);

	switch( testNumber ) {

		case eF2_ColoredLines:
			{
				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempNumpoints = 2;
				for (i=0; i<120; i++)
				{
					tempCorner[0].x = 50.+i*4;	tempCorner[0].y = 460.;
					tempCorner[1].x = 50.+i*4;	tempCorner[1].y = 460.-i*3;
					tempColor[0].r = i;	tempColor[0].g = i+.5;	tempColor[0].b = i+1.;	tempColor[0].a = 1.;
					F2_ColoredLines (gGState, tempNumpoints, tempCorner, tempColor);
				}
				GS_SendList(gGState);
				GS_WaitIO(gGState);
				LogResult(PASSED, "");
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
			}
			break;

		case eF2_CopyRect:
			{
			    Bitmap*		theBitMap = (Bitmap*)LookupItem(GS_GetDestBuffer(gGState));

				tempCorner[0].x = 180.;	tempCorner[0].y = 100.;
				tempCorner[1].x = 250.;	tempCorner[1].y = 250.;
				tempCorner[2].x = 200.;	tempCorner[2].y = 200.;
				F2_CopyRect (gGState,
								theBitMap->bm_Buffer,					/* void		*sptr */
									theBitMap->bm_Width,				/* int32	width */
										theBitMap->bm_Type,				/* int32	type */
											&tempCorner[0],				/* Point2	*src */
												&tempCorner[1],			/* Point2	*dest */
													&tempCorner[2]);	/* Point2	*size */
   				GS_SendList(gGState);
    			GS_WaitIO(gGState);
 				LogResult(PASSED, "");
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
			}
			break;

		case eF2_Draw:
			{
				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempSprite = Spr_Create(0);
				Spr_CreateTxData (tempSprite, gTexture, 16, 16, 2, MAKEEXPFORMAT (0, 0, 1, 0, 0, 0, 2));
				Spr_CreatePipControlBlock (tempSprite, gPipData, 0, sizeof(gPipData)/sizeof(gPipData[0]));
				Do_Texturing(tempSprite);
				Spr_ResetCorners (tempSprite, SPR_TOPLEFT);
				Spr_Translate (tempSprite, 150, 100);
				Spr_Scale (tempSprite, 10., 10.);
				gErr = F2_Draw (gGState, tempSprite);
				if (gErr < 0) {
					LogResult(FAILED, "Unable to draw.  Error# %d", gErr);
				} else {
					LogResult(PASSED, "");
					GS_SendList(gGState);
					GS_WaitIO(gGState);
				}
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
				Spr_Delete(tempSprite);
			}
			break;

		case eF2_DrawLine:
			{
				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempCorner[0].x = 0.;	tempCorner[0].y = 0.;
				tempCorner[1].x = 640.;	tempCorner[1].y = 480.;
				tempColor[0].r = 0.;	tempColor[0].g = 0.;	tempColor[0].b = 1.;	tempColor[0].a = 1.;
				tempColor[1].r = 1.;	tempColor[1].g = 0.;	tempColor[1].b = 0.;	tempColor[1].a = 0.;
				F2_DrawLine (gGState, &tempCorner[0], &tempCorner[1], &tempColor[0], &tempColor[1]);
				LogResult(PASSED, "");
				GS_SendList(gGState);
				GS_WaitIO(gGState);
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
			}
			break;

		case eF2_DrawList:
			{
				List		theList;

				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempSprite = Spr_Create(0);
				Spr_CreateTxData (tempSprite, gTexture, 16, 16, 2, MAKEEXPFORMAT (0, 0, 1, 0, 0, 0, 2));
				Spr_CreatePipControlBlock (tempSprite, gPipData, 0, sizeof(gPipData)/sizeof(gPipData[0]));
				Do_Texturing(tempSprite);
				Spr_ResetCorners (tempSprite, SPR_TOPLEFT);
				Spr_Translate (tempSprite, 50, 50);
				Spr_Scale (tempSprite, 5., 5.);
				F2_Draw (gGState, tempSprite);

				temp1Sprite = Spr_Create(0);
				Spr_CreateTxData (temp1Sprite, ggTexture, 16, 16, 2, MAKEEXPFORMAT (0, 0, 1, 0, 0, 0, 2));
				Spr_CreatePipControlBlock (temp1Sprite, gPipData, 0, sizeof(gPipData)/sizeof(gPipData[0]));
				Do_Texturing(temp1Sprite);
				Spr_ResetCorners (temp1Sprite, SPR_TOPLEFT);
				Spr_Translate (temp1Sprite, 150, 150);
				Spr_Scale (temp1Sprite, 5., 5.);
				F2_Draw (gGState, temp1Sprite);

				PrepList(&theList);
				InsertNodeFromHead(&theList, &(tempSprite->spr_Node));
				InsertNodeFromHead(&theList, &(temp1Sprite->spr_Node));
				gErr = F2_DrawList (gGState, &theList);
				if (gErr < 0) {
					LogResult(FAILED, "Unable to draw list.  Error# %d", gErr);
				} else {
					LogResult(PASSED, "");
					GS_SendList(gGState);
					GS_WaitIO(gGState);
				}
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
				Spr_Delete(tempSprite);
				Spr_Delete(temp1Sprite);
			}
			break;

		case eF2_FillRect:
			{
				gfloat		tempRectX1, tempRectX2, tempRectY1, tempRectY2;

				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempRectX1 = 100.;			tempRectY1 = 100.;
				tempRectX2 = 540.;			tempRectY2 = 380.;
				tempColor[0].r = 0.5, tempColor[0].g = 0.5, tempColor[0].b = 0.5, tempColor[0].a = 1.;
				F2_FillRect (gGState, tempRectX1, tempRectY1, tempRectX2, tempRectY2, &tempColor[0]);
				LogResult(PASSED, "");
				GS_SendList(gGState);
				GS_WaitIO(gGState);
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
			}
			break;

		case eF2_Point:
			{
				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempColor[0].r = 1.;	tempColor[0].g = 0.;	tempColor[0].b = 0.;	tempColor[0].a = 1.0;
				for (i=0; i<100; i++)
				{
					tempCorner[0].x = i*4.0;	tempCorner[0].y = i*4.0;
					F2_Point (gGState, tempCorner[0].x, tempCorner[0].y, &tempColor[0]);
				}
				LogResult(PASSED, "");
				GS_SendList(gGState);
				GS_WaitIO(gGState);
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
			}
			break;

		case eF2_Points:
			{
				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempNumpoints = 1;
				tempColor[0].r = 0.;	tempColor[0].g = 1.;	tempColor[0].b = 0.;	tempColor[0].a = 1.0;
				for (i=0; i<100; i++)
				{
					tempCorner[0].x = i*4.0;	tempCorner[0].y = i*4.0;
					F2_Points (gGState, tempNumpoints, tempCorner, tempColor);
				}
				LogResult(PASSED, "");
				GS_SendList(gGState);
				GS_WaitIO(gGState);
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
			}
			break;

		case eF2_ShadedLines:
			{
				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempNumpoints = 2;
				for (i=0; i<700; i++)
				{
					tempCorner[0].x = i;	tempCorner[0].y = 10.+0.;
					tempCorner[1].x = i;	tempCorner[0].y = 40.+i;
					tempColor[0].r = 0.+i*100;	tempColor[0].g = 0.+i*100;	tempColor[0].b = 1.;	tempColor[0].a = 1.;
					F2_ShadedLines (gGState, tempNumpoints, tempCorner, tempColor);
				}
				LogResult(PASSED, "");
				GS_SendList(gGState);
				GS_WaitIO(gGState);
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
			}
			break;

		case eF2_Triangles:
			{
				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempCorner[0].x = 40.;		tempCorner[0].y = 40.;
				tempCorner[1].x = 600.;		tempCorner[1].y = 40.;
				tempCorner[2].x = 40.;		tempCorner[2].y = 440.;
				tempColor[0].r = 1.;	tempColor[0].g = 0.;	tempColor[0].b = 0.;	tempColor[0].a = 1.;
				tempColor[1].r = 0.;	tempColor[1].g = 1.;	tempColor[1].b = 0.;	tempColor[1].a = 1.;
				tempColor[2].r = 0.;	tempColor[2].g = 0.;	tempColor[2].b = 1.;	tempColor[2].a = 1.;
				tempColor[3].r = 1.;	tempColor[3].g = 0.;	tempColor[3].b = 0.;	tempColor[3].a = 1.;
				gErr = F2_Triangles (gGState, GEOF2_COLORS, 3, tempCorner, tempColor, 0);
				if (gErr < 0) {
					LogResult(FAILED, "F2_Triangles failed.  Error# %d", gErr);
				} else {
					LogResult(PASSED, "");
					GS_SendList(gGState);
					GS_WaitIO(gGState);
				}
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
			}
			break;

		case eF2_TriFan:
			{
				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempCorner[0].x = 40.;		tempCorner[0].y = 440.;
				tempCorner[1].x = 600.;		tempCorner[1].y = 40.;
				tempCorner[2].x = 600.;		tempCorner[2].y = 440.;
				tempColor[0].r = 1., tempColor[0].g = 0., tempColor[0].b = 0., tempColor[0].a = 1.;
				tempColor[1].r = 0., tempColor[1].g = 1., tempColor[1].b = 0., tempColor[1].a = 1.;
				tempColor[2].r = 0., tempColor[2].g = 0., tempColor[2].b = 1., tempColor[2].a = 1.;
				tempColor[3].r = 1., tempColor[3].g = 0., tempColor[3].b = 0., tempColor[3].a = 1.;
				gErr = F2_TriFan (gGState, GEOF2_COLORS, 3, tempCorner, tempColor, 0);
				if (gErr < 0) {
					LogResult(FAILED, "F2_TriFan failed.  Error # %d", gErr);
				} else {
					LogResult(PASSED, "");
					GS_SendList(gGState);
					GS_WaitIO(gGState);
				}
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
			}
			break;

		case eF2_TriStrip:
			{
				CLT_ClearFrameBuffer (gGState, 0., 0., 0., 0., TRUE, TRUE);
				tempCorner[0].x = 240.;	tempCorner[0].y = 154.;
				tempCorner[1].x = 320.;	tempCorner[1].y = 230.;
				tempCorner[2].x = 240.;	tempCorner[2].y = 230.;
				tempColor[0].r = 1., tempColor[0].g = 0., tempColor[0].b = 0., tempColor[0].a = 1.;
				tempColor[1].r = 0., tempColor[1].g = 1., tempColor[1].b = 0., tempColor[1].a = 1.;
				tempColor[2].r = 0., tempColor[2].g = 0., tempColor[2].b = 1., tempColor[2].a = 1.;
				tempColor[3].r = 1., tempColor[3].g = 0., tempColor[3].b = 0., tempColor[3].a = 1.;
				gErr = F2_TriStrip (gGState, GEOF2_COLORS, 3, tempCorner, tempColor, 0);
				if (gErr < 0) {
					LogResult(FAILED, "F2_TriStrip failed.  Error # %d", gErr);
				} else {
					LogResult(PASSED, "");
					GS_SendList(gGState);
					GS_WaitIO(gGState);
				}
				if (gCPadFlag)
				{
					printf ("Press a button...\n");
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
					while( !GetControlPad (1, FALSE, &tempCPad)) ;
				}
			}
			break;

		default:
			BeginTest(FT, "<Invalid Test>");
			LogComment("Test called with an invalid testNumber (%d)", testNumber );
	}
}

/* -------------------------------------------------------------------------------- */
