/*
 *	Scaffold.h
 *
 *  Provide Class like wrappers for M2_Scaffold
 *
 */

#ifdef MACINTOSH
#include <misc:event.h>
#include <:tests:3do_scaf.h>
#else
#include <misc/event.h>
#include <tests/3do_scaf.h>

#endif

#include <assert.h>

typedef struct {
	char*		testName;
	eTestType	testType;
} TestBlockData ;

/* Member data */
typedef struct {
	TestBlockData		tbd;
	ControlPadEventData	cped;
} SCAFFOLD;

/* Member Functions */
SCAFFOLD* 	Scaffold_Construct( int argc, char* argv[], char* progName );
void		Scaffold_Initialize(int argc, char* argv[], char* progName );
void		Scaffold_Destruct(void);
void		Scaffold_Print(void);

			/* All report functions write to the concole and of the log file */
void		Scaffold_Report(eTestResult result, char * InString, ...);
void		Scaffold_ReportPassed(void);
void		Scaffold_ReportUnTested(void);
void		Scaffold_ReportComment(char * InString, ...);
void		Scaffold_ReportError(int32 err );
void		Scaffold_ReportFinal(void);

			/* All console functions write only to the console */
void		Scaffold_ConsoleComment(char * InString, ...);

			/* Interactive verify */
eTestResult	Scaffold_InteractiveVerify(char* promptString, Boolean shouldSetResult);
int32		Scaffold_Query(char *promptString );

/* End of File */
