/*
 * @(#) FindAndOpenNamedItem.c 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		FindAndOpenNamedItem.c

	Contains:	test the FindAndOpenNamedItem call

	Written by:	Eric Hegstrom
	

	Copyright:	 1994 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 12/12/94	ELH		created

	To Do:
*/


#include "globals.h"


/*****************************************************************************/
Err TestFindAndOpenNamedItem( int32	indx)
{
	Item	aItem;
	uint8	aFType;
	uint8	aNType;
	char	*itemName;
	Boolean	expErr;
	
	aFType 		= TFINDANDOPENNAMEDITEM[indx].aFType;
	aNType 		= TFINDANDOPENNAMEDITEM[indx].aNType;
	itemName 	= TFINDANDOPENNAMEDITEM[indx].itemName;
	expErr 		= TFINDANDOPENNAMEDITEM[indx].expErr;
	
	
	if (strcmp("NULL_STRING", itemName) == 0)
		itemName = NULL;
		
	if (itemName != NULL)
		sprintf( gTestName, "FindAndOpenNamedItem | f= %d; n= %d; name = \"%s\"",aFType, aNType, itemName );
	else
		sprintf( gTestName, "FindAndOpenNamedItem | f= %d; n= %d; name = NULL",aFType, aNType );
		
	if (expErr == true) strcat(gTestName, kExpectErrorStr);
		
	BeginTest( BAT, gTestName);
	
	aItem = FindAndOpenNamedItem( MKNODEID( aFType, aNType ), itemName);	

	if (itemName == NULL) itemName = "NULL";

	if ( (aItem < 0)&&(!expErr) )
	{
		LogResult( FAILED, "Error opening item name = '%s' FOLIO = %d  TYPE = %d",
			itemName, aFType, aNType );
		LogError( aItem );
	}
	else if ( (aItem >= 0)&&(expErr) )
	{
		LogResult( FAILED, "Unexpected Success opening item name = '%s' FOLIO = %d  TYPE = %d",
			itemName, aFType, aNType );
			
	}
	else if (aItem < 0)
	{
		LogResult( PASSED, "Expected Error opening item name = '%s' FOLIO = %d  TYPE = %d", 
			itemName, aFType, aNType );
	}
	else
	{
		LogResult( PASSED, "Opened item name = '%s' FOLIO = %d  TYPE = %d", itemName, aFType, aNType );
	}
	
/*	if (aItem >= 0) LogError( CloseItem( aItem ) );	*/

	return aItem;
}

