/*
 * @(#) IsItemOpened.c 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		IsItemOpened.c

	Contains:	test the IsItemOpened call

	Written by:	Eric Hegstrom
	

	Copyright:	 1994 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 12/12/94	ELH		created

	To Do:
*/


#include "globals.h"


/*****************************************************************************/
Err TestIsItemOpened( int32	indx)
{
	Item	aItem;
	uint8	aFType;
	uint8	aNType;
	char	*itemName;
	int32	openErr;
	
	aFType 		= TISITEMOPENED[indx].aFType;
	aNType 		= TISITEMOPENED[indx].aNType;
	itemName 	= TISITEMOPENED[indx].itemName;
	
	if (strcmp("NULL_STRING", itemName) == 0)
		itemName = NULL;
		
	if (itemName != NULL)
		sprintf( gTestName, "IsItemOpened | f= %d; n= %d; name = \"%s\"",aFType, aNType, itemName );
	else
		sprintf( gTestName, "IsItemOpened | f= %d; n= %d; name = NULL",aFType, aNType, itemName );
		
		
	BeginTest( BAT, gTestName);
	
	aItem = FindAndOpenNamedItem( MKNODEID( aFType, aNType ), itemName);
	
	openErr = IsItemOpened( CURRENTTASKITEM, aItem );

	if (openErr < 0) strcat(gTestName, kExpectErrorStr);
	
	if ((aItem < 0)&&(openErr < 0))
	{
		LogResult( PASSED, "IsItemOpened says item isn't open and it isn't");
		return 1;
	}
	else if ((aItem < 0)&&(openErr >= 0))
	{
		LogResult( FAILED, "IsItemOpened says item is open and it isn't");
		return -1;
	}
	else if (openErr < 0)
	{
		LogResult( FAILED, "IsItemOpened says item isn't open and it is");
		return -1;
	}
	else		/* it's working correctly so far so let's close the item and see what it says */
	{
		LogResult( PASSED, "IsItemOpened seems to work properly");
		return 1;
	}
}

