
/*
 * @(#) CompTestTypes.h 96/10/21 1.2
 */


#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */

/*
	File:		CompTestType.h

	Contains:	

	Written by:	Eric Hegstrom

	Copyright:	 1994 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 10/26/94	ELH		Created

	To Do:
*/

/* This file contains the type definitions for the Compression Tests */


#include <kernel/types.h>

#include <stdio.h>
#include <kernel/mem.h>
#include <misc/compression.h>
/* #include "hardware.h" */
#include "CompressUtils.h"

#define		CompDebug 0


/*****************************************************************************/
/*   PROTOTYPES    */


void FillRandomWord(	void *dest, uint32 wordCount);

Err TestCreateCompressorVA( int32 indx, Boolean	skipZeroTags);
Err TestCreateCompressor( 	int32 indx, Boolean	skipZeroTags);

Err TestDeleteCompressor( 	int32 indx );

Err TestCompress( int32	indx);
Err TestDecompress( int32	indx);

Err TestOpenCompress(  int32	num);
Err TestCloseCompress( int32	num);

Err TestFeedCompressor( int32	indx);
Err TestFeedDecompressor( int32	indx);


/* ************************************************** */
/*  CreateCompressorVA test descriptions */

#define			numTCCVA	5

typedef struct {
	
	Compressor	**comp;
	CompFunc	cf;
	void		**workBufHdl;
	void		*userData;
	Boolean		expErr;
	char		*name;
}	TCCVAtype;

/* ************************************************** */
/*  CreateCompressor test descriptions */

#define			numTCC	5

typedef struct {
	
	Compressor	**comp;
	CompFunc	cf;
	void		**workBufHdl;
	void		*userData;
	Boolean		expErr;
	char		*name;
}	TCCtype;

/* ************************************************** */
/*  DeleteCompressor test descriptions */

#define			numTDC	5

typedef struct {
	
	Compressor	**comp;
	CompFunc	cf;
	void		**workBufHdl;
	void		*userData;
	Boolean		expErr;
	char		*name;
}	TDCtype;

/* ************************************************** */
/*  Compress test descriptions */

#define			numTC	6

typedef struct {
	uint32		srcSize;
	uint32		srcWords;
	uint32		destSize;
	uint32		destWords;
	Boolean		expErr;
	char		*name;
}	TCtype;

/* ************************************************** */
/*  Compress test descriptions */

#define			numTD	6

typedef struct {
	uint32		srcSize;
	Boolean		expErr;
	char		*name;
}	TDtype;


/* ************************************************** */
/*  FeedDecompressor test descriptions */

#define			numTFD	6

typedef struct {
	
	Compressor		**comp;
	Decompressor	**deComp;
	CompFunc	cf;
	CompFunc	df;
	void		**workBufHdl;
	void		*userData;
	uint32		srcSize;
	Boolean		expErr;
	char		*name;
}	TFDtype;


/* ************************************************** */
/*  FeedCompressor test descriptions */

#define			numTFC	6

typedef struct {
	
	Compressor	**comp;
	CompFunc	cf;
	void		**workBufHdl;
	void		*userData;
	uint32		srcSize;
	Boolean		expErr;
	char		*name;
}	TFCtype;


