
/*
 * @(#) CompressUtils.c 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"
#include	<kernel/random.h>

#include "globals.h"



/*****************************************************************************/
/* Fills dest with wordCount number od 32bit words */

void FillRandomWord(void *dest, uint32 wordCount)
{
	uint32	*data;
	uint32	n;
	
	data = (uint32 *)dest;
	
	for (n = 0; n < wordCount; n++)
	{
		data[n] = ReadHardwareRandomNumber();
	}
	
}


/*****************************************************************************/
Boolean CompareMem( void *srcData, void *decompData, int32 compSize )
{
	uint32	*data1;
	uint32	*data2;
	uint32	n;
	
	data1 = (uint32 *)srcData;
	data2 = (uint32 *)decompData;
	
	for (n = 0; n < compSize; n++)
	{
		if (data1[n] != data2[n])
			return FALSE;
	}
	return TRUE;
}


/*****************************************************************************/
void PutCompressedWord(void *context, uint32 word)
{
	TOUCH(context);

	if (compressedIndex < compressedMaxSize)
		compressedData[compressedIndex++] = word;
	else if (!compErrorEncountered)
	{
		LogResult(UNRESOLVED, "Not enough memory in compression destination ");
		compErrorEncountered = TRUE;
	}
}


/*****************************************************************************/
void PutFinalWord(void *context, uint32 word)
{
	TOUCH(context);

	if (finalIndex < finalMaxSize)
		finalData[finalIndex++] = word;
	else if (!compErrorEncountered)
	{
		LogResult(UNRESOLVED, "Not enough memory in decompression destination ");
		compErrorEncountered = TRUE;
	}
}

/*****************************************************************************/
void DPutCompressedWord(void *context, uint32 word)
{
	TOUCH(context);
	TOUCH(word);
}


/*****************************************************************************/
void DPutFinalWord(void *context, uint32 word)
{
	TOUCH(context);
	TOUCH(word);
}


/*****************************************************************************/

