
/*
 * @(#) CreateCompressor.c 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		CreateCompressor.c

	Contains:	Test The Compression Lib Written by ric Hegstrom

	Written by:	Eric Hegstrom
	

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 10/25/94	ELH		created

	To Do:
*/


#include "globals.h"

/*****************************************************************************/
Err TestCreateCompressorVA( int32	indx,
							Boolean	skipZeroTags)
{
	Err           err;

	

	gTestName = TCCVA[indx].name;
	BeginTest( BAT, gTestName);

	if (skipZeroTags)
	{
		if( (*(TCCVA[indx].workBufHdl)) == 0 )
			err = CreateCompressorVA(	TCCVA[indx].comp,
										TCCVA[indx].cf,
										COMP_TAG_USERDATA, TCCVA[indx].userData,
										TAG_END, 0);
			
		else if( TCCVA[indx].userData == 0 )
			err = CreateCompressorVA(	TCCVA[indx].comp,
										TCCVA[indx].cf,
										COMP_TAG_WORKBUFFER, *(TCCVA[indx].workBufHdl),	
										TAG_END, 0);
	
		else if ( (*(TCCVA[indx].workBufHdl) == 0 ) && ( TCCVA[indx].userData == 0 ) )
			err = CreateCompressorVA(	TCCVA[indx].comp,
										TCCVA[indx].cf,
										TAG_END, 0);
	
		else
			err = CreateCompressorVA(	TCCVA[indx].comp,
										TCCVA[indx].cf,
										COMP_TAG_WORKBUFFER, *(TCCVA[indx].workBufHdl),
										COMP_TAG_USERDATA, TCCVA[indx].userData,
										TAG_END, 0);
	}
	else
		err = CreateCompressorVA(	TCCVA[indx].comp,
									TCCVA[indx].cf,
									COMP_TAG_WORKBUFFER, *(TCCVA[indx].workBufHdl),
									COMP_TAG_USERDATA, TCCVA[indx].userData,
									TAG_END, 0);


	if ( (err >= 0)&&(!TCCVA[indx].expErr) )
	{
        LogResult(PASSED, "CreateCompressor No Error" );
    }
	else if ( (err < 0)&&(TCCVA[indx].expErr) )
	{
        LogResult(PASSED, "CreateCompressor Expected Error # $%x",err );
		/* LogError(err);	*/
    }
	else if (err < 0)
	{
        LogResult(FAILED, "CreateCompressor Unexpected Error # $%x",err);
		LogError(err);
	}
	else if (err >= 0)
	{
        LogResult(FAILED, "CreateCompressor Unexpexted No-Error ");
	}
	
	if (err >= 0)
	{
		err = DeleteCompressor( *(TCCVA[indx].comp) );
		if (err < 0) 
		{
			LogComment("   DeleteCompressor returns error $%x", err);
			LogError(err);
		}
	}
			
	return err;

}

/*****************************************************************************/
Err TestCreateCompressor( 	int32	indx,
							Boolean	skipZeroTags)
{
	Err			err;
	uint32		n = 0;
	TagArg		targs[4];

	gTestName = TCC[indx].name;
	BeginTest( BAT, gTestName);


	if(  ( *(TCC[indx].workBufHdl) != 0 ) || !skipZeroTags )
	{
		targs[n].ta_Tag = COMP_TAG_WORKBUFFER;
		targs[n++].ta_Arg = *(TCC[indx].workBufHdl);
	}

	if(  ( TCC[indx].userData != 0 )  || !skipZeroTags )
	{
		targs[n].ta_Tag = COMP_TAG_USERDATA;
		targs[n++].ta_Arg = TCC[indx].userData;
	}

	targs[n].ta_Tag = TAG_END;
	targs[n].ta_Arg = 0;

	err = CreateCompressor(	TCC[indx].comp, TCC[indx].cf, targs);

	if ( (err >= 0)&&(!TCC[indx].expErr) )
	{
        LogResult(PASSED, "CreateCompressor No Error" );
    }
	else if ( (err < 0)&&(TCC[indx].expErr) )
	{
        LogResult(PASSED, "CreateCompressor Expected Error # $%x",err );
		/* LogError(err); */
    }
	else if (err < 0)
	{
        LogResult(FAILED, "CreateCompressor Unexpected Error # $%x",err);
		LogError(err);
	}
	else if (err >= 0)
	{
        LogResult(FAILED, "CreateCompressor Unexpexted No-Error ");
	}
	
	if (err >= 0)
	{
		err = DeleteCompressor( *(TCC[indx].comp) );
		if (err < 0) 
		{
			LogComment("   DeleteCompressor returns error $%x", err);
			LogError(err);
		}
	}
		
	return err;
}

