
/*
 * @(#) DeleteCompressor.c 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		CreateCompressor.c

	Contains:	Test The Compression Lib Written by ric Hegstrom

	Written by:	Eric Hegstrom
	

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 11/14/94	ELH		created

	To Do:
*/


#include "globals.h"


/*****************************************************************************/
Err TestDeleteCompressor( 	int32	indx	)
{
	Err			err;
	uint32		n = 0;
	TagArg		targs[4];

	gTestName = TDC[indx].name;
	BeginTest( BAT, gTestName);


	targs[n].ta_Tag = COMP_TAG_WORKBUFFER;
	targs[n++].ta_Arg = *(TDC[indx].workBufHdl);
	
	targs[n].ta_Tag = COMP_TAG_USERDATA;
	targs[n++].ta_Arg = TDC[indx].userData;

	targs[n].ta_Tag = TAG_END;
	targs[n].ta_Arg = 0;

	err = CreateCompressor(	TDC[indx].comp, TDC[indx].cf, targs);

	if (err < 0)
	{
        LogResult(UNRESOLVED, "CreateCompressor Unexpected Error # $%x",err);
		LogError(err);
	}
	
	if (err >= 0)
	{
		err = DeleteCompressor( *(TDC[indx].comp) );
		if ( (err >= 0)&&(!TDC[indx].expErr) )
		{
			LogResult(PASSED, "DeleteCompressor No Error" );
		}
		else if ( (err < 0)&&(TDC[indx].expErr) )
		{
			LogResult(PASSED, "DeleteCompressor Expected Error # $%x",err );
			/* LogError(err); */
		}
		else if (err < 0)
		{
			LogResult(FAILED, "DeleteCompressor Unexpected Error # $%x",err);
			LogError(err);
		}
		else if (err >= 0)
		{
			LogResult(FAILED, "DeleteCompressor Unexpexted No-Error ");
		}
	}
		
	return err;
}

