
/*
 * @(#) FeedCompressor.c 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		FeedDecompressor.c

	Contains:	Test The Compression Folio

	Written by:	Eric Hegstrom
	

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 11/14/94	ELH		created

	To Do:
*/


#include "globals.h"
#include "CompressUtils.h"

#define	FD_CLEANUP	if (srcData != NULL) free( srcData );			\
					if (destData != NULL) free( destData );			\
					compressedIndex = 0;							\
					finalIndex = 0;									\
					compErrorEncountered = FALSE;


/*****************************************************************************/
Err TestFeedCompressor( int32	indx)
{
	#define		compOverhead 2500

	Err				err = -1;
	void			*srcData;
	void			*destData;

	gTestName = TFC[indx].name;
	BeginTest( BAT, gTestName);
	compressedMaxSize = TFC[indx].srcSize+compOverhead;
	
	srcData = (void *) malloc( TFC[indx].srcSize*sizeof(uint32) );
	if (( srcData == NULL )&&( TFC[indx].srcSize*sizeof(uint32) != 0))
	{
		LogResult(UNRESOLVED, "Error Allocating srcData # $%x",err );
		return -1;
	}

	destData = (void *) malloc( compressedMaxSize*sizeof(uint32) );
	if (( destData == NULL )&&( compressedMaxSize*sizeof(uint32) != 0))
	{
		LogResult(UNRESOLVED, "Error Allocating destData # $%x",err );
		FD_CLEANUP
		return -1;
	}

	
/* do this so the compressor function know where to put the data */
	compressedData = (uint32 *)destData;

	
	FillRandomWord( srcData, TFC[indx].srcSize );
	
/* create the compressor */

	err = CreateCompressorVA(	TFC[indx].comp,
								TFC[indx].cf,
								COMP_TAG_WORKBUFFER, *(TFC[indx].workBufHdl),
								COMP_TAG_USERDATA, TFC[indx].userData,
								TAG_END, 0);
	if (err < 0)
	{
		LogResult(UNRESOLVED, "CreateCompressor Error # $%x",err );
		LogError(err);
		FD_CLEANUP
		return err;
	}
	
/* do the compression */
	err = FeedCompressor( *(TFC[indx].comp), srcData, TFC[indx].srcSize );

	if ( (err >= 0)&&(!TFC[indx].expErr) )
	{
		LogResult( PASSED, "FeedCompressor returns validl" );
	}
	else if ( (err < 0)&&(TFC[indx].expErr) )
	{
		LogResult(PASSED, "FeedCompressor Expected Error # $%x",err );
		/* LogError(err); */
	}
	else if (err < 0)
	{
		LogResult(FAILED, "FeedCompressor Unexpected Error # $%x",err);
		LogError(err);
	}
	else if (err >= 0)
	{
		LogResult(FAILED, "FeedCompressor Unexpexted No-Error ");
	}
	
	err = DeleteCompressor( *(TFC[indx].comp) );
	if ( err < 0 )
	{
		LogResult(UNRESOLVED, "DeleteCompressor Error # $%x",err );
		LogError(err);
		FD_CLEANUP
		return err;
	}
	
	if (compErrorEncountered)
	{
		FD_CLEANUP
		return -1;
	}
	
/* create the decompressor */


	

	FD_CLEANUP

	return err;
}

