
/*
 * @(#) CreateAliasTests.c 96/10/21 1.2
 */

#include "FileUtils.h"


/* ====================================================================	*/
/*	CreateAlias		Tests					*/
/* ====================================================================	*/
/* --------------------------------------------------- */
void	TestOneCreateAlias(	char	*aliasPath,
							char	*realPath,
							char	*testPath,
							Boolean	expErr)

{
	char			testName[128];
	Item			aItem;
	
	if( aliasPath == NULL )	aliasPath = "_NULL_PTR_";		/* check for NULL path string pointers */
	if( realPath == NULL )	realPath  = "_NULL_PTR_";
	if( testPath == NULL )	testPath  = "_NULL_PTR_";

	sprintf( testName, "CreateAlias(\"%s\", \"%s\") check for \"%s\"", aliasPath, realPath, testPath );
		
	BeginTest(BAT, testName);
	
	
	if ( (aItem = CreateAlias( aliasPath, realPath )) < 0)
	{
		if (!expErr)
		{
			LogError(aItem );
			LogResult(FAILED, "CreateAlias Returns UNEXPECTED error $%x", aItem);
		}
		else
			LogResult(PASSED, "CreateAlias Returns expected error $%x", aItem);
			
		return;
	}

	LogResult(PASSED, "CreateAlias executed with no error ");

#if 0  /* this functional testing disabled because it's not correct *.

	exists = FileExists( testPath );		/* call with a string that must have an alias resolved */
	
											/* check if result was what we expected */
	if(( !exists ) && ( expErr ) )
		LogResult(PASSED, "Couldn't resolve alias (this was expected)");
	else if (( !exists ) && ( !expErr ) )
		LogResult(FAILED, "Couldn't resolve alias but expected to");
	else if ( expErr )
		LogResult(FAILED, "Could resolve alias but didn't expect to");
	else 
		LogResult(PASSED, "Could resolve alias as expected");

#endif
}


/* --------------------------------------------------- */
void	TestCreateAlias(void )
{
	
	TestOneCreateAlias( "b", "/remote/", "bMy_OpenFileTest", FALSE );
	TestOneCreateAlias( "cab", "/remote/This_File_Name_Is_Too_Long_Hi_Ho_Hi_Ho_Its_off_to_code_we_go_", "cab", TRUE );
	TestOneCreateAlias( "b", "/remote/", "bxyzabc", FALSE );
	TestOneCreateAlias( "bac", "/remote/CHK3", "bac", FALSE );
	
}

