#include "FileUtils.h"




/* ====================================================================	*/
/*						CreateFile		Tests							*/
/* ====================================================================	*/
/* --------------------------------------------------- */
void	TestOneCreateFile(	char	*path,
							Boolean	expErr	)

{
	char			testName[128];
	Err				err;
	
	if( path == NULL )
		strcpy ( testName, "CreateFile(_NULL_PTR_)" );
	else
		sprintf( testName, "CreateFile(\"%s\")", path );
	if ( expErr )						
		strcat ( testName, " - ExpErr" );

	BeginTest(BAT, testName);
	
	
	if (MyDeleteFile( path ) < 0)					/* get rid of file if it already exists */
	{
		LogResult(UNRESOLVED, "Problem deleting file -- cannot test CreateFile(\"%s\")", path);
		return;
	}
	
	err = CreateFile( path );				/* attempt to make the file */
	
											/* check if result was what we expected */
	if(( err < 0 ) && ( expErr ) )
	{
		LogError(err );
		LogResult(PASSED, "CreateFile(\"%s\") returns expected error $%x", path, err);
	}
	else if (( err < 0 ) && ( !expErr ) )
	{
		LogError(err );
		LogResult(FAILED, "CreateFile(\"%s\") returns UNEXPECTED error $%x", path, err);
	}
	else if ( expErr )
		LogResult(FAILED, "CreateFile(\"%s\") didn't return the expected error ", path);
	else 
	{
		if ( !expErr && !FileExists( path ) )	/* for some reason the file wasn't actually created */
			LogResult(FAILED, "File not openable yet CreateFile(\"%s\") executed without error", path);
		else
			LogResult(PASSED, "CreateFile(\"%s\") executed properly", path);
	}	
		
	if (err >= 0)						/* let's cleanup and delete it */
		MyDeleteFile( path );
		
}

/* --------------------------------------------------- */
void	TestCreateFile(void )
{
	
	TestOneCreateFile( "/remote/My_Sharona", FALSE );
	TestOneCreateFile( "/remote/This_File_Name_Is_Too_Long_Hi_Ho_Hi_Ho_Its_off_to_code_we_go_", TRUE );
	TestOneCreateFile( "/remote/x", FALSE );
	
}


