
/*
 * @(#) TestDoIO.h 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		TestDoIO.h

	Contains:	Test routines for DoIO() (Header).

	Written by:	Charlie Eckhaus

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 7/23/93	CDE		Derived from TestShell.c V1.7

	To Do:
*/


#include "threadUtils.h"
#include "msgUtils.h"
#include "ioUtils.h"


/************************************EXTRA TEST ENV GLOBALS**************************/
extern	char	* gTestAreaName;
extern	Boolean	gInvalidArg;
extern	Boolean gTestHasExpectedResult;


/************************************TEST ENV GLOBALS**************************/
extern	int32	gFlag;
extern	Boolean gContinue;
extern	char	* gProgName;		/* contains the name of the program */
extern	char	* gTestName;		/* contains the name of the test    */
extern	int32	gTestLevel;			/* contains what level of testing occurs in this test */
extern	int32	gTestType;			/* interactive or automated */

/* Index for parameter-testing */
extern long gCurrentIndex;



/***** Function Prototypes *****/
Boolean		VerifyDoIO ( Boolean beforeCall, long aIndx, Err aResult, Item ioRequest, IOInfo *ioInfo );
long		CallDoIO (  long currentOuterIteration, long minInnerIterations, long maxInnerIterations );
void		TestDoIO( long minOuterIterations, long maxOuterIterations );

