
/*
 * @(#) LumberJackTests.c 96/10/21 1.2
 */

#include <kernel/types.h>
#include <kernel/item.h>
#include <kernel/debug.h>
#include <kernel/list.h>
#include <kernel/device.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <kernel/lumberjack.h>

#include "LumberJackUtils.h"
#include <tests/3do_scaf.h>

#define LOG_ALL_LUMBERJACK LOGF_CONTROL_USER | LOGF_CONTROL_TASKS | LOGF_CONTROL_INTERRUPTS | LOGF_CONTROL_SIGNALS | LOGF_CONTROL_MESSAGES | LOGF_CONTROL_SEMAPHORES | LOGF_CONTROL_PAGES | LOGF_CONTROL_ITEMS | LOGF_CONTROL_IOREQS

#define MIN_LOG_STR 65
#define MAX_LOG_STR 80

void tf1 (void )
{
	char *p;
	
	p = (char *) malloc( 12 );
	free(p);
}

void tf2 (void )
{
	int32 n = 0;
	char tstr[2048];
	char tstr2[128];
	
	
		
	printf( tstr2, "-- Will attempt to log string of length %d", n);
	tstr[n] = '\0';
	LogEvent( tstr );

	for (n =0 ;  n <= MIN_LOG_STR; n++)
	{
		tstr[n] = 'x';
	}
	tstr[n+1] = '\0';
	for (n = MIN_LOG_STR;  n < MAX_LOG_STR; n++)
	{
		printf( tstr2, "-- Will attempt to log string of length %d", n);
		tstr[n-1] = 'x';
		tstr[n] = '\0';
		LogEvent( tstr );
	}
}

int main (int32 argc, char *argv[])
{
	int32			n;
	

	InitScaffold( KERNEL, argc, argv );
	
	
	kprintf("log all = %x\n", LOG_ALL_LUMBERJACK );
#if 0	
	TestCreateLumberjack( );
	TestDeleteLumberjack( );

	TestControlLumberjack( 0 );
	TestControlLumberjack( LOG_ALL_LUMBERJACK );
	TestControlLumberjack( 0xA5 );
	
#endif
	TestControlLumberjack( 9 );
	TestControlLumberjack( 10 );
	
#if 0
	if (!ql)
		for (n = 1; n < 0xFF; n++)
			TestControlLumberjack( n );	
#endif

	TestObtainLumberjackBuffer( LOG_ALL_LUMBERJACK, tf1, "tf1");
	
	TestReleaseLumberjackBuffer( LOG_ALL_LUMBERJACK, tf1, "tf1");
	
	TestDumpLumberjackBuffer( LOG_ALL_LUMBERJACK, tf1, "tf1", "This is tf1 banner");
	
	TestLogEvent( LOGF_CONTROL_USER, tf2, "tf2", "This is tf2 banner");
	
	
	TermScaffold();
	
	return 1;
}

