
/*
 * @(#) TestGetThisMsg.h 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		TestGetThisMsg.h

	Contains:	Test routines for GetThisMsg() (Header).

	Written by:	Charlie Eckhaus

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 7/21/93	CDE		Derived from shell V1.6

	To Do:
*/


#include "msgUtils.h"


/************************************EXTRA TEST ENV GLOBALS**************************/
extern	char	* gTestAreaName;
extern	Boolean	gInvalidArg;
extern	Boolean gTestHasExpectedResult;

/************************************TEST ENV GLOBALS**************************/
extern	int32	gFlag;
extern	Boolean gContinue;
extern	char	* gProgName;		/* contains the name of the program */
extern	char	* gTestName;		/* contains the name of the test    */
extern	int32	gTestLevel;			/* contains what level of testing occurs in this test */
extern	int32	gTestType;			/* interactive or automated */

/* Index for parameter-testing */
extern long gCurrentIndex;


/***** Checklist:

	 Change the "File" and "Contains" lines above to reflect the name of your call
	 Change the name in the "Written by" line above to your name
	 Add Change History lines above the previous lines:
		- Increment the change number
		- Specify the date, your initials, and a brief description of the change(s)
		- When you first change this file, add "<2> (date) (initials) Derived from shell"
	 Change the function prototypes below to reflect the name of your call 
	 Look for bulleted () HINTS below.
*/

/***** Function Prototypes *****/
Boolean		VerifyGetThisMsg ( Boolean beforeCall, long aIndx, Item aResult, Item message );
long		CallGetThisMsg (  long currentOuterIteration, long minInnerIterations, long maxInnerIterations );
void		TestGetThisMsg( long minOuterIterations, long maxOuterIterations );

