
/*
 * @(#) PersistentMem.c 96/10/21 1.2
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <kernel/mem.h>
#include <kernel/item.h>
#include <kernel/types.h>
#include <kernel/kernelnodes.h>
#include <kernel/nodes.h>
#include <kernel/task.h>
#include <tests/3do_scaf.h>






  
int main (int32 argc, char *argv[])
  {
	Err err;
	MemInfo *minfo;
	PersistentMemInfo *info;
	char choice;
	if (argc > 1)
	{
	 	choice = *argv[1];
		
	}
	else
	{
		printf("no arguments supplied\n");
		printf("specify (i)nitial or (r)eboot as a command parameter.\n");
		exit(0);
	}
	
	if (choice == 'i')
	{
		printf("running for first time\n");
		
		
		minfo = AllocMem(sizeof(MemInfo),MEMTYPE_NORMAL);
		/*setting up data structure to save -- note that*/
		/*I am only using a MemInfo structure for convenience -- */
		/*any structure would do just fine*/
		
		minfo->minfo_TaskAllocatedPages = 1;
		minfo->minfo_TaskAllocatedBytes = 2;
		minfo->minfo_FreePages = 3;
		minfo->minfo_LargestFreePageSpan = 4;
		minfo->minfo_SystemAllocatedPages = 5;
		minfo->minfo_SystemAllocatedBytes = 6;
		minfo->minfo_OtherAllocatedPages = 7;
		
		
		
		
		
		/*now, try to set what we just initialized to be persistent*/
		err = ControlMem(minfo,sizeof(MemInfo),MEMC_PERSISTENT,0);
		if (err < 0)
		{
			printf("ControlMem returned a bad code- rc=%d\n",err);
			exit(-1);
		}
		
		/*now exit.  When we re-run specify 'r' and try to access the persistent memory */
		exit(0);
	}
	else if (choice == 'r')
	{
		printf("running for second time\n");
		/*do this for kicks, to see if a regular allocmem messes*/
		/*up the persistent memory*/
		minfo = AllocMem(sizeof(MemInfo),MEMTYPE_NORMAL);
		if (minfo == NULL)
		{
		    printf("Memory Allocation Error\n");
		    exit(-1);
		}
		info = AllocMem(sizeof(PersistentMemInfo),MEMTYPE_NORMAL);
		
		/*now try to allocate the persistent memory*/
		err = GetPersistentMem(info,sizeof(PersistentMemInfo));
		if (err < 0)
		{
			printf("GetPersistentMem returned error: rc=%d\n",err);
			exit(-1);
		}
		minfo = info->pinfo_Start;
		printf("Persistent Data:  %d %d %d %d %d %d %d \n",
				minfo->minfo_TaskAllocatedPages,
				minfo->minfo_TaskAllocatedBytes,
				minfo->minfo_FreePages,
				minfo->minfo_LargestFreePageSpan,
				minfo->minfo_SystemAllocatedPages,
				minfo->minfo_SystemAllocatedBytes,
				minfo->minfo_OtherAllocatedPages);
				
		exit(0);
	}
	else
	{
		printf("choice must start with (i) or (r)\n");
		exit(0);
	}
	
	
	
}

