
/*
 * @(#) TimeLaterThan.c 96/10/22 1.3
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		TimeLaterThan.c

	Contains:	Code to test new Timer support calls.
	Note:		New calls

	Written by:	Miriam Poursaied

	Date:		November 30, 1994
	
	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

*/



#include <kernel/types.h>
#include "ctype.h"
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <kernel/mem.h>
#include <kernel/time.h>



#include "TimerTests.h"

void TestTimeLaterThan()
{
	
	TimeVal time1,time2;
	Item val;
	bool result;
	Err err;
	
	BeginTest( BAT, "TimeLaterThan");
	
	val=CreateTimerIOReq();	
	if (val < 0)
	{
		LogResult(UNRESOLVED,"CreateTimerIOReq failed");
		return;
	}	
		
	else
	{
		SampleSystemTimeTV(&time1);
		if((time1.tv_sec >= 0) && (time1.tv_usec >= 0))
		{
			LogDiagnostic( 12, "time 1 in seconds: %d",time1.tv_sec);
			LogDiagnostic( 12, "time 1 in microseconds: %d",time1.tv_usec);
		}
		else
		{
			LogResult(UNRESOLVED,"SampleSystemTimeTV failed");
			return;
		}
		
		SampleSystemTimeTV(&time2);
		if((time1.tv_sec >= 0) && (time1.tv_usec >= 0))
		{
			LogDiagnostic( 12, "time 2 in seconds: %d",time2.tv_sec);
			LogDiagnostic( 12, "time 2 in microseconds: %d",time2.tv_usec);
		}
		else
		{
			LogResult(UNRESOLVED,"SampleSystemTimeTV failed");
			return;
		}
	}	
	result=TimeLaterThan(&time2,&time1);
	LogDiagnostic( 12, "*************************");
	LogDiagnostic( 12, " If (t1 > t2)  : TRUE");
	LogDiagnostic( 12, " If (t1 < t2)  : FALSE");
	LogDiagnostic( 12, "result = %d",result);
	err=DeleteTimerIOReq(val);
	if (err < 0)
	{
		LogResult(UNRESOLVED,"DeleteTimerIOReq failed");
		return;
	}	
	
	LogResult( PASSED, NULL );
}

