
/*
 * @(#) TimerTests.c 96/10/22 1.3
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		WaitUntil.c

	Contains:	Code to test new Timer support calls.
	Note:		New calls

	Written by:	Eric Hegstrom

	Date:		9/12/95
	
	Copyright:	 1993-1995 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

*/



#include <kernel/types.h>
#include "ctype.h"
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <kernel/mem.h>
#include <kernel/time.h>


#include "TimerTests.h"



int32 		gFlag;  										
Boolean 	gContinue;
char 		* gProgName 	= "TimerTests";			/* contains the name of the program */
char 		* gTestName 	= "TimerTests";			/* contains the name of the test */
int32 		gTestLevel 		= BREADTH;							/* contains what level of testing occurs in this test */
int32 		gTestType 		= 0;	


int main (int argc,char **argv)
{
		
	InitScaffold( KERNEL, argc, argv);					/* initializes this program */

	gTestName 	= "AddTimes";
	TestAddTimes();

	gTestName 	= "AddTimesStress";
	TestAddTimesStress();

	gTestName 	= "CompareTimes";
	TestCompareTimes();

	gTestName 	= "CompareTimesStress";
	TestCompareTimesStress();

#if 0
	gTestName 	= "SampleSystemTime";
	TestSampleSystemTime();
#endif

	gTestName 	= "SampleSystemTimeTV";
	TestSampleSystemTimeTV();

	gTestName 	= "SubTimes";
	TestSubTimes();

	gTestName 	= "SubTimesStress";
	TestSubTimesStress();

	gTestName 	= "TimeLaterStress";
	TestTimeLaterStress();

	gTestName 	= "TimeLaterThan";
	TestTimeLaterThan();

	gTestName 	= "TimeLaterThanOrEqual";
	TestTimeLaterThanOrEqual();

	gTestName 	= "TimeLaterThanStress";
	TestTimeLaterThanStress();

	gTestName 	= "WaitTime";
	TestWaitTime();

	gTestName 	= "WaitTimeStress";
	TestWaitTimeStress();

#if 0
	gTestName 	= "WaitUntil";
	TestWaitUntil();
#endif

	TermScaffold();
	
	return ( 1 );

}

