
/*
 * @(#) WaitUntil.c 96/10/22 1.3
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		WaitUntil.c

	Contains:	Code to test new Timer support calls.
	Note:		New calls

	Written by:	Miriam Poursaied

	Date:		November 30, 1994
	
	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

*/



#include <kernel/types.h>
#include "ctype.h"
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <kernel/mem.h>
#include <kernel/time.h>


#include "TimerTests.h"


#define Until_sec 5550
#define Until_micsec  760983 




void TestWaitUntil()
{
	
	TimeVal time1;
	Item val;
	Err err,wait;
	
	/******************************************************************************/
	BeginTest( BAT, "WaitUntil");
	
	val=CreateTimerIOReq();	
	if (val < 0)
	{
		LogResult(UNRESOLVED,"CreateTimerIOReq failed");
		return;
	}	
		
	else
	{
		SampleSystemTimeTV(&time1);
		if((time1.tv_sec >= 0) && (time1.tv_usec >= 0))
		{
			LogDiagnostic( 12, "time 1 in seconds: %d",time1.tv_sec);
			LogDiagnostic( 12, "time 1 in microseconds: %d",time1.tv_usec);
			LogDiagnostic( 12, "requested wait-until-time in sec: %d, in microseconds: %d",Until_sec,Until_micsec);
		}
		else
		{
			LogResult(UNRESOLVED,"SampleSystemTimeTV failed");
			return;
		}	
	}	
	wait=WaitUntil(val,Until_sec,Until_micsec);
	if (wait < 0)
	{
		LogResult(FAILED,"WaitUntil failed ");
		return;
	}	
	else if (time1.tv_sec > Until_sec)
	{
		LogDiagnostic( 12, "System time has already been passed the wait-time");
	}	
	
	else
	{
		LogDiagnostic( 12, "WaitUntil completed successfully= %d",wait);
		err=DeleteTimerIOReq(val);
		if (err < 0)
		{
			LogResult(UNRESOLVED,"DeleteTimerIOReq failed");
			return;
		}	
		LogResult( PASSED, NULL );
	}	
				
		
	

}

