/*
	File:		tests.h

	Contains:	prototypes for DSAPISuite tests

	Written by:	amasri

	Copyright:	 1996 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <4>	 5/14/96	PUT YOUR INITIALS HERE		add SetChannelMask declaration
		 <3>	  5/2/96	am		add new tests

	To Do:
*/



/* Copyright (C) 1995, an unpublished work by The 3DO Company.*/
/* All rights reserved. This material contains confidential*/
/* information that is the property of The 3DO Company. Any*/
/* unauthorized duplication, disclosure or use is prohibited.*/
/* */
/* @(#) tests.h 96/07/10 1.1
/* Distributed with Portfolio V28.0*/

#ifndef _TESTS_H_
#define _TESTS_H_

#include <string.h>				/* memset */
#include <kernel/debug.h>
#include <kernel/mem.h>			/* for AllocMemTrack, FreeMemTrack   */
#include <audio/audio.h>
#include <graphics/view.h>		/* VIEWTAG_BITMAP */

#include <streaming/datastreamlib.h>
#include <streaming/dsstreamdefs.h>
#include <streaming/satemplatedefs.h>
#include <streaming/sacontrolmsgs.h>

#include "testvideostream.h"
#include "joypad.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

Err DoMemPoolTest(void);
Err DoClockTest(PlayerPtr ctx);
Err DoEZFlixCurrTimeTest(EZFlixRecPtr channel);
Err DoEZFlixDurationTest(EZFlixRecPtr channel);
Err DoChannelMaskTest(PlayerPtr ctx);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	/* _TESTS_H_ */
