/* Header file for tokenised sdf data types. */
/* This file is automatically generated by mkheader */

#include "parsertypes.h"

#define NEXT_BUFFER 0xffffffff	/* For joining buffers together */
#define CLASS_PAD 0x0000ffff
#define SDF_UNITS 0x0000fffe
#define USE_SYMBOL 0x0000fffd
#define SYMBOL_NAME 0x0000fffc

typedef struct TokenHead
{
	uint32 flags;
	float version;
	uint32 size;
} TokenHead;
#define TH_ADDR_DELTA 1	/* Addresses are delta values */
#define ADDRESS(th, c, o) \
(((th)->flags & TH_ADDR_DELTA) ? \
 ((uint32)(c) + (o)) : (o))


/* These are the values for the units */
enum ENUM_UNITS
{
	ENUM_UNITS_METERS = 0,
	ENUM_UNITS_KMETERS,
	ENUM_UNITS_FEET,
	ENUM_UNITS_INCHES,
	ENUM_UNITS_NAUTMILES,
	ENUM_UNITS_INTEGER
};


#define CLASS_OBJECT 0x10000
enum eCLASS_OBJECT
{
	CLASS_OBJECT_DUMMY = 0x10001
};

enum ENUM_BOOL
{
	ENUM_BOOL_TRUE = 1,
	ENUM_BOOL_FALSE = 0,
	ENUM_BOOL_YES = 1,
	ENUM_BOOL_NO = 0,
	ENUM_BOOL_ENABLE = 1,
	ENUM_BOOL_DISABLE = 0,
	ENUM_BOOL_ON = 1,
	ENUM_BOOL_OFF = 0
};

enum ENUM_SDF_SHADE
{
	ENUM_SDF_SHADE_AMBIENT = 1,
	ENUM_SDF_SHADE_DIFFUSE = 2,
	ENUM_SDF_SHADE_SPECULAR = 4,
	ENUM_SDF_SHADE_EMISSIVE = 8,
	ENUM_SDF_SHADE_TWOSIDED = 16
};

enum ENUM_SDF_TXGTYPE
{
	ENUM_SDF_TXGTYPE_USER = 0,
	ENUM_SDF_TXGTYPE_CYLINDRICAL = 1,
	ENUM_SDF_TXGTYPE_SPHERICAL = 2,
	ENUM_SDF_TXGTYPE_XY = 3,
	ENUM_SDF_TXGTYPE_XZ = 4,
	ENUM_SDF_TXGTYPE_YZ = 5,
	ENUM_SDF_TXGTYPE_ENVIRONMENT = 6
};

enum ENUM_SDF_CYLPART
{
	ENUM_SDF_CYLPART_SIDES = 1,
	ENUM_SDF_CYLPART_TOP = 2,
	ENUM_SDF_CYLPART_BASE = 4,
	ENUM_SDF_CYLPART_ALL = 8
};

enum ENUM_SDF_BLENDOP
{
	ENUM_SDF_BLENDOP_LERP = 0,
	ENUM_SDF_BLENDOP_MULT = 1
};

enum ENUM_SDF_WRAPMODE
{
	ENUM_SDF_WRAPMODE_CLAMP = 0,
	ENUM_SDF_WRAPMODE_TILE = 1
};

enum ENUM_SDF_FILTER
{
	ENUM_SDF_FILTER_NEAREST = 0,
	ENUM_SDF_FILTER_LINEAR = 1,
	ENUM_SDF_FILTER_BILINEAR = 2,
	ENUM_SDF_FILTER_QUASITRILINEAR = 3
};

enum ENUM_SDF_COLORSEL
{
	ENUM_SDF_COLORSEL_CONSTCOLOR = 0,
	ENUM_SDF_COLORSEL_CONSTALPHA = 1,
	ENUM_SDF_COLORSEL_TEXCOLOR = 2,
	ENUM_SDF_COLORSEL_TEXALPHA = 3,
	ENUM_SDF_COLORSEL_PRIMCOLOR = 4,
	ENUM_SDF_COLORSEL_PRIMALPHA = 5
};

enum ENUM_SDF_ALPHASEL
{
	ENUM_SDF_ALPHASEL_PRIMALPHA = 4,
	ENUM_SDF_ALPHASEL_TEXALPHA = 3,
	ENUM_SDF_ALPHASEL_CONSTALPHA = 1
};

enum ENUM_SDF_PIPSEL
{
	ENUM_SDF_PIPSEL_CONST = 0,
	ENUM_SDF_PIPSEL_TEXTURE = 1,
	ENUM_SDF_PIPSEL_COLORTABLE = 2
};

enum ENUM_SDF_BLENDOUT
{
	ENUM_SDF_BLENDOUT_PRIM = 0,
	ENUM_SDF_BLENDOUT_TEXTURE = 1,
	ENUM_SDF_BLENDOUT_BLEND = 2
};

enum ENUM_SDF_LIGHTKIND
{
	ENUM_SDF_LIGHTKIND_DIRECTIONAL = 0,
	ENUM_SDF_LIGHTKIND_POINT = 1,
	ENUM_SDF_LIGHTKIND_SPOT = 2,
	ENUM_SDF_LIGHTKIND_SOFTSPOT = 3
};

enum ENUM_SDF_CAMKIND
{
	ENUM_SDF_CAMKIND_PERSPECTIVE = 0,
	ENUM_SDF_CAMKIND_ORTHOGRAPHIC = 1
};

enum ENUM_SDF_ENGCONTROL
{
	ENUM_SDF_ENGCONTROL_ONCE = 0,
	ENUM_SDF_ENGCONTROL_CYCLE = 1
};

enum ENUM_SDF_ENGSTATUS
{
	ENUM_SDF_ENGSTATUS_IDLE = 0,
	ENUM_SDF_ENGSTATUS_ACTIVE = 1
};

enum ENUM_VTX_FORMAT
{
	ENUM_VTX_FORMAT_LOCATIONS = 0,
	ENUM_VTX_FORMAT_NORMALS = 1,
	ENUM_VTX_FORMAT_COLORS = 2,
	ENUM_VTX_FORMAT_TEXCOORDS = 4
};

enum ENUM_SDF_VTXORDER
{
	ENUM_SDF_VTXORDER_CLOCKWISE = 0,
	ENUM_SDF_VTXORDER_COUNTERCLOCKWISE = 1
};

enum ENUM_SDF_AXIS
{
	ENUM_SDF_AXIS_XAXIS = 0,
	ENUM_SDF_AXIS_YAXIS = 1,
	ENUM_SDF_AXIS_ZAXIS = 2
};

#define ARRAY_SHORTARRAY 0x4000000
#define ARRAY_FLOATARRAY 0x5000000
#define ARRAY_COLOR 0x6000000
#define ARRAY_COLORARRAY 0x7000000
#define ARRAY_POINT 0x8000000
#define ARRAY_POINTARRAY 0x9000000
#define ARRAY_TEXCOORD 0xa000000
#define ARRAY_BOX 0xb000000
#define ARRAY_TRANSFORM 0xc000000
#define ARRAY_VTX 0xd000000
#define ARRAY_VTX_ARRAY 0xe000000
#define ARRAY_TEXCOORDARAY 0xf000000
#define CLASS_MATERIAL 0x20000
enum eCLASS_MATERIAL
{
	CLASS_MATERIAL_AMBIENT = 0x20001,
	CLASS_MATERIAL_DIFFUSE = 0x20002,
	CLASS_MATERIAL_EMISSION = 0x20003,
	CLASS_MATERIAL_SPECULAR = 0x20004,
	CLASS_MATERIAL_SHADEENABLE = 0x20005,
	CLASS_MATERIAL_SHINE = 0x20006
};

#define CLASS_SDF_TEXGEN 0x30000
enum eCLASS_SDF_TEXGEN
{
	CLASS_SDF_TEXGEN_KIND = 0x30001,
	CLASS_SDF_TEXGEN_TRANSFORM = 0x30002,
	CLASS_SDF_TEXGEN_UREPEAT = 0x30003,
	CLASS_SDF_TEXGEN_VREPEAT = 0x30004,
	CLASS_SDF_TEXGEN_TEXSCALE = 0x30005,
	CLASS_SDF_TEXGEN_TEXOFFSET = 0x30006,
	CLASS_SDF_TEXGEN_TRANSLATE = 0x30007,
	CLASS_SDF_TEXGEN_ROTATE = 0x30008,
	CLASS_SDF_TEXGEN_SCALE = 0x30009
};

#define CLASS_VTX_LIST 0x40000
enum eCLASS_VTX_LIST
{
	CLASS_VTX_LIST_FORMAT = 0x40001,
	CLASS_VTX_LIST_VERTICES = 0x40002,
	CLASS_VTX_LIST_LOCATIONS = 0x40003,
	CLASS_VTX_LIST_NORMALS = 0x40004,
	CLASS_VTX_LIST_COLORS = 0x40005,
	CLASS_VTX_LIST_TEXCOORDS = 0x40006
};

#define CLASS_TRIMESH 0x50000
enum eCLASS_TRIMESH
{
	CLASS_TRIMESH_VERTEXLIST = 0x50001,
	CLASS_TRIMESH_VERTEXCOUNT = 0x50002,
	CLASS_TRIMESH_VERTEXINDICES = 0x50003
};

#define CLASS_QUADMESH 0x60000
enum eCLASS_QUADMESH
{
	CLASS_QUADMESH_VERTEXLIST = 0x60001,
	CLASS_QUADMESH_VERTICESPERROW = 0x60002,
	CLASS_QUADMESH_VERTICESPERCOLUMN = 0x60003
};

#define CLASS_GEOMETRY 0x70000
enum eCLASS_GEOMETRY
{
	CLASS_GEOMETRY_VERTEXLIST = 0x70001
};

#define ARRAY_MATARRAY 0x10000000
#define CLASS_CUBE 0x80000
enum eCLASS_CUBE
{
	CLASS_CUBE_SIZE = 0x80001
};

#define CLASS_BLOCK 0x90000
enum eCLASS_BLOCK
{
	CLASS_BLOCK_WIDTH = 0x90001,
	CLASS_BLOCK_HEIGHT = 0x90002,
	CLASS_BLOCK_DEPTH = 0x90003
};

#define CLASS_SPHERE 0xa0000
enum eCLASS_SPHERE
{
	CLASS_SPHERE_RADIUS = 0xa0001,
	CLASS_SPHERE_COMPLEXITY = 0xa0002
};

#define CLASS_ELLIPSOID 0xb0000
enum eCLASS_ELLIPSOID
{
	CLASS_ELLIPSOID_X_RADIUS = 0xb0001,
	CLASS_ELLIPSOID_Y_RADIUS = 0xb0002,
	CLASS_ELLIPSOID_Z_RADIUS = 0xb0003,
	CLASS_ELLIPSOID_COMPLEXITY = 0xb0004
};

#define CLASS_TORUS 0xc0000
enum eCLASS_TORUS
{
	CLASS_TORUS_IRADIUS = 0xc0001,
	CLASS_TORUS_ORADIUS = 0xc0002,
	CLASS_TORUS_COMPLEXITY = 0xc0003
};

#define CLASS_CYLINDER 0xd0000
enum eCLASS_CYLINDER
{
	CLASS_CYLINDER_PARTS = 0xd0001,
	CLASS_CYLINDER_RADIUS = 0xd0002,
	CLASS_CYLINDER_HEIGHT = 0xd0003,
	CLASS_CYLINDER_COMPLEXITY = 0xd0004
};

#define CLASS_TRUNCATEDCONE 0xe0000
enum eCLASS_TRUNCATEDCONE
{
	CLASS_TRUNCATEDCONE_PARTS = 0xe0001,
	CLASS_TRUNCATEDCONE_TOP_RADIUS = 0xe0002,
	CLASS_TRUNCATEDCONE_BASE_HEIGHT = 0xe0003,
	CLASS_TRUNCATEDCONE_COMPLEXITY = 0xe0004
};

#define CLASS_CHARACTER 0xf0000
enum eCLASS_CHARACTER
{
	CLASS_CHARACTER_CULLING = 0xf0001,
	CLASS_CHARACTER_VISIBLE = 0xf0002,
	CLASS_CHARACTER_TRANSFORM = 0xf0003,
	CLASS_CHARACTER_LOOKAT = 0xf0004,
	CLASS_CHARACTER_MOVE = 0xf0005,
	CLASS_CHARACTER_TRANSLATE = 0xf0006,
	CLASS_CHARACTER_TURN = 0xf0007,
	CLASS_CHARACTER_ROTATE = 0xf0008,
	CLASS_CHARACTER_SCALE = 0xf0009,
	CLASS_CHARACTER_SIZE = 0xf000a,
	CLASS_CHARACTER_ROLL = 0xf000b,
	CLASS_CHARACTER_PITCH = 0xf000c,
	CLASS_CHARACTER_YAW = 0xf000d
};

#define CLASS_ENGINE 0x100000
enum eCLASS_ENGINE
{
	CLASS_ENGINE_SPEED = 0x100001,
	CLASS_ENGINE_STARTTIME = 0x100002,
	CLASS_ENGINE_DURATION = 0x100003,
	CLASS_ENGINE_STATUS = 0x100004,
	CLASS_ENGINE_CONTROL = 0x100005
};

#define CLASS_ENGLINK 0x110000
enum eCLASS_ENGLINK
{
	CLASS_ENGLINK_OBJECT = 0x110001,
	CLASS_ENGLINK_ENGINE = 0x110002
};

#define CLASS_TEXTURE 0x120000
enum eCLASS_TEXTURE
{
	CLASS_TEXTURE_FILENAME = 0x120001
};

#define CLASS_PIPTABLE 0x130000
enum eCLASS_PIPTABLE
{
	CLASS_PIPTABLE_FILENAME = 0x130001
};

#define CLASS_SURFACE 0x140000
enum eCLASS_SURFACE
{
	CLASS_SURFACE_AUTONORMALS = 0x140001,
	CLASS_SURFACE_AUTOTEXCOORDS = 0x140002,
	CLASS_SURFACE_NORMALIZEDTEXCOORDS = 0x140003,
	CLASS_SURFACE_MATERIAL = 0x140004,
	CLASS_SURFACE_MATINDEX = 0x140005,
	CLASS_SURFACE_TEXINDEX = 0x140006,
	CLASS_SURFACE_NORMAL = 0x140007,
	CLASS_SURFACE_COLOR = 0x140008,
	CLASS_SURFACE_TEXGEN = 0x140009,
	CLASS_SURFACE_CUBE = 0x14000a,
	CLASS_SURFACE_BLOCK = 0x14000b,
	CLASS_SURFACE_SPHERE = 0x14000c,
	CLASS_SURFACE_TORUS = 0x14000d,
	CLASS_SURFACE_ELLIPSOID = 0x14000e,
	CLASS_SURFACE_CYLINDER = 0x14000f,
	CLASS_SURFACE_CONE = 0x140010,
	CLASS_SURFACE_TRUNCATEDCONE = 0x140011,
	CLASS_SURFACE_TRIANGLES = 0x140012,
	CLASS_SURFACE_TRISTRIP = 0x140013,
	CLASS_SURFACE_TRIFAN = 0x140014,
	CLASS_SURFACE_POLYGON = 0x140015,
	CLASS_SURFACE_POINTS = 0x140016,
	CLASS_SURFACE_LINES = 0x140017,
	CLASS_SURFACE_QUADMESH = 0x140018,
	CLASS_SURFACE_TRIMESH = 0x140019
};

#define CLASS_TEXBLEND 0x150000
enum eCLASS_TEXBLEND
{
	CLASS_TEXBLEND_FILENAME = 0x150001,
	CLASS_TEXBLEND_TEXTURE = 0x150002,
	CLASS_TEXBLEND_PIP = 0x150003,
	CLASS_TEXBLEND_FIRSTLOD = 0x150004,
	CLASS_TEXBLEND_NUMLOD = 0x150005,
	CLASS_TEXBLEND_XWRAP = 0x150006,
	CLASS_TEXBLEND_YWRAP = 0x150007,
	CLASS_TEXBLEND_TXMINFILTER = 0x150008,
	CLASS_TEXBLEND_TXMAGFILTER = 0x150009,
	CLASS_TEXBLEND_TXINTERFILTER = 0x15000a,
	CLASS_TEXBLEND_TXPIPINDEXOFFSET = 0x15000b,
	CLASS_TEXBLEND_TXPIPCOLORSEL = 0x15000c,
	CLASS_TEXBLEND_TXPIPALPHASEL = 0x15000d,
	CLASS_TEXBLEND_TXPIPSSBSEL = 0x15000e,
	CLASS_TEXBLEND_TXPIPCONSTSSB0 = 0x15000f,
	CLASS_TEXBLEND_TXPIPCONSTSSB1 = 0x150010,
	CLASS_TEXBLEND_TXFIRSTCOLOR = 0x150011,
	CLASS_TEXBLEND_TXSECONDCOLOR = 0x150012,
	CLASS_TEXBLEND_TXTHIRDCOLOR = 0x150013,
	CLASS_TEXBLEND_TXFIRSTALPHA = 0x150014,
	CLASS_TEXBLEND_TXSECONDALPHA = 0x150015,
	CLASS_TEXBLEND_TXCOLOROUT = 0x150016,
	CLASS_TEXBLEND_TXALPHAOUT = 0x150017,
	CLASS_TEXBLEND_TXBLENDOP = 0x150018,
	CLASS_TEXBLEND_TXBLENDCOLORSSB0 = 0x150019,
	CLASS_TEXBLEND_TXBLENDCOLORSSB1 = 0x15001a,
	CLASS_TEXBLEND_DBLENABLEATTRS = 0x15001b,
	CLASS_TEXBLEND_DBLDISCARD = 0x15001c,
	CLASS_TEXBLEND_DBLXWINCLIPMIN = 0x15001d,
	CLASS_TEXBLEND_DBLXWINCLIPMAX = 0x15001e,
	CLASS_TEXBLEND_DBLYWINCLIPMIN = 0x15001f,
	CLASS_TEXBLEND_DBLYWINCLIPMAX = 0x150020,
	CLASS_TEXBLEND_DBLZCOMPARECONTROL = 0x150021,
	CLASS_TEXBLEND_DBLZXOFFSET = 0x150022,
	CLASS_TEXBLEND_DBLZYOFFSET = 0x150023,
	CLASS_TEXBLEND_DBLDSBSELECT = 0x150024,
	CLASS_TEXBLEND_DBLDSBCONST = 0x150025,
	CLASS_TEXBLEND_DBLAINPUTSELECT = 0x150026,
	CLASS_TEXBLEND_DBLAMULTCOEFSELECT = 0x150027,
	CLASS_TEXBLEND_DBLAMULTCONSTCONTROL = 0x150028,
	CLASS_TEXBLEND_DBLAMULTRTJUSTIFY = 0x150029,
	CLASS_TEXBLEND_DBLBINPUTSELECT = 0x15002a,
	CLASS_TEXBLEND_DBLBMULTCOEFSELECT = 0x15002b,
	CLASS_TEXBLEND_DBLBMULTCONSTCONTROL = 0x15002c,
	CLASS_TEXBLEND_DBLBMULTRTJUSTIFY = 0x15002d,
	CLASS_TEXBLEND_DBLALUOPERATION = 0x15002e,
	CLASS_TEXBLEND_DBLFINALDIVIDE = 0x15002f,
	CLASS_TEXBLEND_DBLDITHERMATRIXA = 0x150030,
	CLASS_TEXBLEND_DBLDITHERMATRIXB = 0x150031,
	CLASS_TEXBLEND_DBLSRCPIXELS32BIT = 0x150032,
	CLASS_TEXBLEND_DBLSRCBASEADDR = 0x150033,
	CLASS_TEXBLEND_DBLSRCXSTRIDE = 0x150034,
	CLASS_TEXBLEND_DBLSRCXOFFSET = 0x150035,
	CLASS_TEXBLEND_DBLSRCYOFFSET = 0x150036,
	CLASS_TEXBLEND_DBLRGBCONSTIN = 0x150037,
	CLASS_TEXBLEND_DBLBMULTCONSTSSB0 = 0x150038,
	CLASS_TEXBLEND_DBLBMULTCONSTSSB1 = 0x150039,
	CLASS_TEXBLEND_DBLAMULTCONSTSSB0 = 0x15003a,
	CLASS_TEXBLEND_DBLAMULTCONSTSSB1 = 0x15003b,
	CLASS_TEXBLEND_DBLALPHA0CLAMPCONTROL = 0x15003c,
	CLASS_TEXBLEND_DBLALPHA1CLAMPCONTROL = 0x15003d,
	CLASS_TEXBLEND_DBLALPHAFRACCLAMPCONTROL = 0x15003e,
	CLASS_TEXBLEND_DBLDESTALPHASELECT = 0x15003f,
	CLASS_TEXBLEND_DBLDESTALPHACONSTSSB0 = 0x150040,
	CLASS_TEXBLEND_DBLDESTALPHACONSTSSB1 = 0x150041,
	CLASS_TEXBLEND_PAGEINDEX = 0x150042,
	CLASS_TEXBLEND_SUBINDEX = 0x150043
};

#define ARRAY_TEXARRAY 0x11000000
#define ARRAY_OBJARRAY 0x12000000
#define ARRAY_LINKARRAY 0x13000000
#define CLASS_GROUP 0x160000
enum eCLASS_GROUP
{
	CLASS_GROUP_dummy = 0	/* An empty definition */
};

#define CLASS_MODEL 0x170000
enum eCLASS_MODEL
{
	CLASS_MODEL_SURFACE = 0x170001,
	CLASS_MODEL_MATERIALS = 0x170002,
	CLASS_MODEL_TEXTURES = 0x170003
};

#define CLASS_LIGHT 0x180000
enum eCLASS_LIGHT
{
	CLASS_LIGHT_KIND = 0x180001,
	CLASS_LIGHT_COLOR = 0x180002,
	CLASS_LIGHT_ANGLE = 0x180003,
	CLASS_LIGHT_FALLOFF = 0x180004,
	CLASS_LIGHT_ENABLED = 0x180005
};

#define CLASS_CAMERA 0x190000
enum eCLASS_CAMERA
{
	CLASS_CAMERA_KIND = 0x190001,
	CLASS_CAMERA_ASPECT = 0x190002,
	CLASS_CAMERA_HEIGHT = 0x190003,
	CLASS_CAMERA_FIELDOFVIEW = 0x190004,
	CLASS_CAMERA_HITHER = 0x190005,
	CLASS_CAMERA_VIEWVOLUME = 0x190006,
	CLASS_CAMERA_YON = 0x190007
};

#define CLASS_SCENE 0x1a0000
enum eCLASS_SCENE
{
	CLASS_SCENE_BACKCOLOR = 0x1a0001,
	CLASS_SCENE_STATIC = 0x1a0002,
	CLASS_SCENE_DYNAMIC = 0x1a0003,
	CLASS_SCENE_ENGINES = 0x1a0004,
	CLASS_SCENE_LINKS = 0x1a0005,
	CLASS_SCENE_CAMERA = 0x1a0006,
	CLASS_SCENE_AMBIENT = 0x1a0007,
	CLASS_SCENE_VIEWVOLUME = 0x1a0008,
	CLASS_SCENE_VISIBILITY = 0x1a0009,
	CLASS_SCENE_AUTOCLIP = 0x1a000a,
	CLASS_SCENE_AUTOADJUST = 0x1a000b,
	CLASS_SCENE_SHOWALL = 0x1a000c
};

#define CLASS_KF_OBJECT 0x1b0000
enum eCLASS_KF_OBJECT
{
	CLASS_KF_OBJECT_TARGET = 0x1b0001,
	CLASS_KF_OBJECT_OBJPIVOT = 0x1b0002,
	CLASS_KF_OBJECT_PRNTPIVOT = 0x1b0003,
	CLASS_KF_OBJECT_POSFRAMES = 0x1b0004,
	CLASS_KF_OBJECT_POSDATA = 0x1b0005,
	CLASS_KF_OBJECT_POSSPLDATA = 0x1b0006,
	CLASS_KF_OBJECT_ROTFRAMES = 0x1b0007,
	CLASS_KF_OBJECT_ROTDATA = 0x1b0008,
	CLASS_KF_OBJECT_ROTSPLDATA = 0x1b0009,
	CLASS_KF_OBJECT_SCLFRAMES = 0x1b000a,
	CLASS_KF_OBJECT_SCLDATA = 0x1b000b,
	CLASS_KF_OBJECT_SCLSPLDATA = 0x1b000c
};

#define ARRAY_KFOBJARRAY 0x14000000

